# Dynamic Polynomials

| **Build Status** | **References to cite** |
|:----------------:|:----------------------:|
| [![Build Status][build-img]][build-url] | [![DOI][zenodo-img]][zenodo-url] |
| [![Codecov branch][codecov-img]][codecov-url] | |

Sparse dynamic representation of multivariate polynomials that can be used with [MultivariatePolynomials](https://github.com/JuliaAlgebra/MultivariatePolynomials.jl) (see the documentation there for more information).
Both commutative and non-commutative variables are supported.
The following types are defined:

* `Variable{V,M}`: A variable which is commutative with `*` when `V<:Commutative`. Commutative variables are created using the `@polyvar` macro, e.g. `@polyvar x y`, `@polyvar x[1:8]` and non-commutative variables are created likewise using the `@ncpolyvar` macro. The type parameter `M` is the monomial ordering.
* `Monomial{V,M}`: A product of variables: e.g. `x*y^2`.
* `MultivariatePolynomials.Term{T,Monomial{V,M}}`: A product between an element of type `T` and a `Monomial{V,M}`, e.g `2x`, `3.0x*y^2`.
* `Polynomial{V,M,T}`: A sum of `Term{T,Monomial{V,M}}`, e.g. `2x + 3.0x*y^2 + y`.

All common algebraic operations between those types are designed to be as efficient as possible without doing any assumption on `T`.
Typically, one imagine `T` to be a subtype of `Number` but it can be anything.
This is useful for example in the package [PolyJuMP](https://github.com/jump-dev/PolyJuMP.jl) where `T` is often an affine expression of [JuMP](https://github.com/jump-dev/JuMP.jl) decision variables.
The commutativity of `T` with `*` is not assumed, even if it is the coefficient of a monomial of commutative variables.
However, commutativity of `T` and of the variables `+` is always assumed.
This allows to keep the terms sorted (Graded Lexicographic order is used) in polynomial and measure which enables more efficient operations.

Below is a simple usage example

```julia
julia> using DynamicPolynomials

julia> @polyvar x y # assigns x (resp. y) to a variable of name x (resp. y)
(x, y)

julia> p = 2x + 3.0x*y^2 + y # define a polynomial in variables x and y
y + 2.0x + 3.0xy²

julia> differentiate(p, x) # compute the derivative of p with respect to x
2.0 + 3.0y²

julia> differentiate.(p, (x, y)) # compute the gradient of p
(2.0 + 3.0y², 1.0 + 6.0xy)

julia> p((x, y)=>(y, x)) # replace any x by y and y by x
2.0y + x + 3.0x²y

julia> subs(p, y=>x^2) # replace any occurence of y by x^2
2.0x + x² + 3.0x⁵

julia> p(x=>1, y=>2) # evaluate p at [1, 2]
16.0
```
Below is an example with `@polyvar x[1:n]`

```julia
julia> n = 3;

julia> @polyvar x[1:n] # assign x to a tuple of variables x1, x2, x3
(Variable{DynamicPolynomials.Commutative{DynamicPolynomials.CreationOrder}, Graded{LexOrder}}[x₁, x₂, x₃],)

julia> p = sum(x .* x) # compute the sum of squares
x₃² + x₂² + x₁²

julia> subs(p, x[1]=>2, x[3]=>3) # make a partial substitution
13 + x₂²

julia> A = reshape(1:9, 3, 3);

julia> p(x => A * vec(x))  # corresponds to dot(A*x, A*x), need vec to convert the tuple to a vector
194x₃² + 244x₂x₃ + 77x₂² + 100x₁x₃ + 64x₁x₂ + 14x₁²
```

The terms of a polynomial are ordered in increasing monomial order. The default
ordering is the graded lex order but it can be modified using the
`monomial_order` keyword argument of the `@polyvar` macro.
We illustrate this below by borrowing the example p. 59 of "Ideals, Varieties and Algorithms"
of Cox, Little and O'Shea:
```julia
julia> p(x, y, z) = 4x*y^2*z + 4z^2 - 5x^3 + 7x^2*z^2
p (generic function with 1 method)

julia> @polyvar x y z monomial_order = LexOrder
(x, y, z)

julia> p(x, y, z) 
4z² + 4xy²z + 7x²z² - 5x³

julia> @polyvar x y z
(x, y, z)

julia> p(x, y, z)
4z² - 5x³ + 4xy²z + 7x²z²

julia> @polyvar x y z monomial_order = Graded{Reverse{InverseLexOrder}}
(x, y, z)

julia> p(x, y, z)
4z² - 5x³ + 7x²z² + 4xy²z
```

Note that, when doing substitution, it is required to give the `Variable` ordering that is meant.
Indeed, the ordering between the `Variable` is not alphabetical but rather by order of creation
which can be undeterministic with parallel computing.
Therefore, this order cannot be used for substitution, even as a default (see [here](https://github.com/JuliaAlgebra/MultivariatePolynomials.jl/issues/3) for a discussion about this).

[build-img]: https://github.com/JuliaAlgebra/DynamicPolynomials.jl/workflows/CI/badge.svg?branch=master
[build-url]: https://github.com/JuliaAlgebra/DynamicPolynomials.jl/actions?query=workflow%3ACI
[codecov-img]: http://codecov.io/github/JuliaAlgebra/DynamicPolynomials.jl/coverage.svg?branch=master
[codecov-url]: http://codecov.io/github/JuliaAlgebra/DynamicPolynomials.jl?branch=master

[zenodo-url]: https://doi.org/10.5281/zenodo.1203245
[zenodo-img]: https://zenodo.org/badge/DOI/10.5281/zenodo.1203245.svg

struct SafeValues{T}
    undefined::BitSet
    values::Vector{T}
end
function Base.setindex!(sv::SafeValues, v, i::Int)
    delete!(sv.undefined, i)
    return sv.values[i] = v
end

function fillmap!(
    vals,
    vars::Vector{<:Variable{C}},
    s::MP.Substitution,
) where {C}
    # We may assign a complex or real variable to its value (ordinary substitution).
    # We follow the following rules:
    # - If a single substitution rule determines the value of a real variable, just substitute it.
    # - If a single substitution rule determines the value of a complex variable or its conjugate, substitute the appropriate
    #   value whereever something related to this variable is found (i.e., the complex variable, the conjugate variable, or
    #   its real or imaginary part)
    # - If a single substitution rule determines the value of the real or imaginary part of a complex variable alone, then only
    #   replace the real or imaginary parts if they occur explicitly. Don't do a partial substitution, i.e., `z` with the rule
    #   `zᵣ => 1` is left alone and not changed into `1 + im*zᵢ`. Even if both the real and imaginary parts are substituted as
    #   two individual rules (which we don't know of in this method), `z` will not be replaced.
    if s.first.kind == REAL
        for j in eachindex(vars)
            if vars[j] == s.first
                vals[j] = s.second
                C == Commutative && break
            end
        end
    else
        s.first.kind == COMPLEX || throw(
            ArgumentError(
                "Substitution with complex variables requires the ordinary_variable in the substitution specification",
            ),
        )
        for j in eachindex(vars)
            if vars[j].variable_order.order.id ==
               s.first.variable_order.order.id
                if vars[j].kind == COMPLEX
                    vals[j] = s.second
                elseif vars[j].kind == CONJ
                    vals[j] = conj(s.second)
                elseif vars[j].kind == REAL_PART
                    vals[j] = real(s.second)
                else
                    vals[j] = imag(s.second)
                end
            end
        end
    end
end
function fillmap!(vals, vars, s::MP.AbstractMultiSubstitution)
    for (v, x) in zip(s.first, s.second)
        fillmap!(vals, vars, v => x)
    end
end

function fillmap!(
    vals,
    vars,
    s1::MP.AbstractSubstitution,
    s2::MP.AbstractSubstitution...,
)
    fillmap!(vals, vars, s1)
    return fillmap!(vals, vars, s2...)
end

_eltype(::T) where {T} = T
_eltype(t::Tuple) = Base.promote_typeof(t...)
_eltype(::Tuple{Vararg{T}}) where {T} = T
_eltype(::AbstractVector{T}) where {T} = T
_substype(s::MP.AbstractSubstitution) = _eltype(s.second)
function _substype(s1::MP.AbstractSubstitution, s2::MP.AbstractSubstitution...)
    return promote_type(_substype(s1), _substype(s2...))
end
_substype(s::MP.Substitutions) = _substype(s...)

function _subsmap(::MP.Eval, vars, s::MP.Substitutions)
    # Every variable should be replaced by some value of type T
    vals = SafeValues(
        BitSet(1:length(vars)),
        Vector{_substype(s)}(undef, length(vars)),
    )
    fillmap!(vals, vars, s...)
    if !isempty(vals.undefined)
        throw(
            ArgumentError(
                "Variable `$(vars[first(vals.undefined)])` was not assigned a value. Use `subs` to substitute only a subset of the variables.",
            ),
        )
    end
    return vals.values
end
function _subsmap(
    ::MP.Subs,
    vars::Vector{Variable{V,M}},
    s::MP.Substitutions,
) where {V,M}
    # Some variable may not be replaced
    vals =
        Vector{promote_type(_substype(s), Variable{V,M})}(undef, length(vars))
    copy!(vals, vars)
    fillmap!(vals, vars, s...)
    return vals
end

subsmap(st, vars, s::MP.Substitutions) = _subsmap(st, vars, s)
_vec(a::AbstractVector) = a
_vec(a::Tuple) = [a...]
function subsmap(st, vars, s::Tuple{MP.VectorMultiSubstitution})
    if vars === s[1].first || vars == s[1].first # shortcut, === happens when the user do p(variables(p) => ...)
        _vec(s[1].second)
    else
        _subsmap(st, vars, s)
    end
end

_add_variables!(α, β) = α
_add_variables!(p::PolyType, α) = p
_add_variables!(α, p::PolyType) = MP.operate!!(*, α, one(p))
function _add_variables!(x::Variable, p::PolyType)
    return MP.operate!!(*, x, one(p))
end
function ___add_variables!(p, q)
    varsvec = [MP.variables(p), MP.variables(q)]
    allvars, maps = mergevars(varsvec)
    if length(allvars) != length(MP.variables(p))
        __add_variables!(p, allvars, maps[1])
    end
    return allvars, maps
end
function _add_variables!(p::PolyType, q::PolyType)
    ___add_variables!(p, q)
    return p
end

function _mono_eval(z::Union{Vector{Int},Tuple}, vals::AbstractVector)
    if length(z) != length(vals)
        error("Cannot evaluate a polynomial of `$(length(z))` variables with only `$(length(vals))` values.")
    end
    if isempty(z)
        return one(eltype(vals))^1
    end
    # `Base.power_by_squaring` does a `copy` if `z[1]` is `1`
    # which is redirected to `MA.mutable_copy`
    val = vals[1]^z[1]
    for i in 2:length(vals)
        if iszero(z[i])
            val = _add_variables!(val, vals[i])
        else
            val = MA.operate!!(*, val, vals[i]^z[i])
        end
    end
    return val
end

MP.substitute(::MP.AbstractSubstitutionType, ::Variable, vals::AbstractVector) = _mono_eval((1,), vals)
MP.substitute(::MP.AbstractSubstitutionType, m::Monomial, vals::AbstractVector) = _mono_eval(m.z, vals)
function MP.substitute(st::MP.AbstractSubstitutionType, t::_Term, vals::AbstractVector)
    return MP.coefficient(t) * MP.substitute(st, MP.monomial(t), vals)
end
function MP.substitute(
    ::MP.Eval,
    p::Polynomial{V,M,T},
    vals::AbstractVector{S},
) where {V,M,T,S}
    # I need to check for iszero otherwise I get : ArgumentError: reducing over an empty collection is not allowed
    if iszero(p)
        zero(MA.promote_operation(*, S, T))
    else
        sum(i -> p.a[i] * _mono_eval(p.x.Z[i], vals), eachindex(p.a))
    end
end
function MP.substitute(
    ::MP.Subs,
    p::Polynomial{V,M,T},
    vals::AbstractVector{S},
) where {V,M,T,S}
    Tout = MA.promote_operation(*, T, MP.coefficient_type(S))
    q = zero_with_variables(
        Polynomial{V,M,Tout},
        mergevars_of(Variable{V,M}, vals)[1],
    )
    for i in eachindex(p.a)
        MA.operate!(+, q, p.a[i] * _mono_eval(p.x.Z[i], vals))
    end
    return q
end

function MA.promote_operation(
    ::typeof(MP.substitute),
    ::Type{MP.Subs},
    ::Type{Monomial{V,M}},
    ::Type{Pair{Variable{V,M},T}},
) where {V,M,T}
    U = MA.promote_operation(*, T, T)
    return MA.promote_operation(*, U, Monomial{V,M})
end

function MP.substitute(
    st::MP.AbstractSubstitutionType,
    p::PolyType,
    s::MP.AbstractSubstitution...,
)
    return MP.substitute(st, p, subsmap(st, MP.variables(p), s))
end

# TODO resolve ambiguity. Can remove after:
# https://github.com/JuliaAlgebra/MultivariatePolynomials.jl/pull/305
function MP.substitute(
    st::MP.AbstractSubstitutionType,
    p::PolyType,
    s::MP.AbstractMultiSubstitution,
)
    return MP.substitute(st, p, subsmap(st, MP.variables(p), (s,)))
end

function MP.substitute(
    st::MP.AbstractSubstitutionType,
    p::PolyType,
    s::MP.Substitutions,
)
    return MP.substitute(st, p, subsmap(st, MP.variables(p), s))
end

(v::Variable)(s::MP.AbstractSubstitution...) = MP.substitute(MP.Eval(), v, s)
(m::Monomial)(s::MP.AbstractSubstitution...) = MP.substitute(MP.Eval(), m, s)
(t::_Term)(s::MP.AbstractSubstitution...) = MP.substitute(MP.Eval(), t, s)
(p::Polynomial)(s::MP.AbstractSubstitution...) = MP.substitute(MP.Eval(), p, s)

(p::Variable)(x::Number) = x
function (p::Monomial)(x::NTuple{N,<:Number}) where {N}
    return MP.substitute(MP.Eval(), p, variables(p) => x)
end
function (p::Monomial)(x::AbstractVector{<:Number})
    return MP.substitute(MP.Eval(), p, x)
end
(p::Monomial)(x::Number...) = MP.substitute(MP.Eval(), p, variables(p) => x)
function (p::_Term)(x::NTuple{N,<:Number}) where {N}
    return MP.substitute(MP.Eval(), p, variables(p) => x)
end
function (p::_Term)(x::AbstractVector{<:Number})
    return MP.substitute(MP.Eval(), p, x)
end
(p::_Term)(x::Number...) = MP.substitute(MP.Eval(), p, variables(p) => x)
function (p::Polynomial)(x::NTuple{N,<:Number}) where {N}
    return MP.substitute(MP.Eval(), p, variables(p) => x)
end
function (p::Polynomial)(x::AbstractVector{<:Number})
    return MP.substitute(MP.Eval(), p, x)
end
(p::Polynomial)(x::Number...) = MP.substitute(MP.Eval(), p, variables(p) => x)

# Product between Variable and Monomial -> Monomial
function Base.:(*)(x::Variable{V,M}, y::Variable{V,M}) where {V<:Commutative,M}
    if x === y
        Monomial([x], [2])
    else
        Monomial(x > y ? [x, y] : [y, x], [1, 1])
    end
end
function multiplyvar(
    v::Vector{Variable{V,M}},
    x::Variable{V,M},
    z,
) where {V<:Commutative,M}
    i = findfirst(Base.Fix2(<=, x), v)
    if (i !== nothing && i > 0) && v[i] == x
        copy(v), multiplyexistingvar(i, z)
    else
        j = (i === nothing || i == 0) ? length(v) + 1 : i
        insertvar(v, x, j), insertvar(z, x, j)
    end
end
function Base.:(*)(x::Variable{V,M}, y::Monomial{V,M}) where {V<:Commutative,M}
    w, z = multiplyvar(y.vars, x, y.z)
    return Monomial(w, z)
end
function Base.:(*)(
    y::MonomialVector{V,M},
    x::Variable{V,M},
) where {V<:Commutative,M}
    return x * y
end
function Base.:(*)(
    x::Variable{V,M},
    y::MonomialVector{V,M},
) where {V<:Commutative,M}
    w, Z = multiplyvar(y.vars, x, y.Z)
    return MonomialVector(w, Z)
end
function _operate_exponents_to!(
    output::Vector{Int},
    op::F,
    z1::Vector{Int},
    z2::Vector{Int},
) where {F<:Function}
    @. output = op(z1, z2)
    return
end
function _operate_exponents_to!(
    output::Vector{Vector{Int}},
    op::F,
    z1::Vector{Vector{Int}},
    z2::Vector{Int},
) where {F<:Function}
    for i in eachindex(output)
        _operate_exponents_to!(output[i], op, z1[i], z2)
    end
    return
end
function _operate_exponents_to!(
    output::Vector{Int},
    op::F,
    z1::Vector{Int},
    z2::Vector{Int},
    maps,
) where {F<:Function}
    I = maps[1]
    i = 1
    lI = length(I)
    J = maps[2]
    j = 1
    lJ = length(J)
    while i <= lI || j <= lJ
        if i > lI || (j <= lJ && J[j] < I[i])
            output[J[j]] = op(0, z2[j])
            j += 1
        elseif j > lJ || (i <= lI && I[i] < J[j])
            output[I[i]] = op(z1[i], 0)
            i += 1
        else
            @assert I[i] == J[j]
            output[I[i]] = op(z1[i], z2[j])
            i += 1
            j += 1
        end
    end
    return
end
function _operate_exponents_to!(
    output::Vector{Vector{Int}},
    op::F,
    z1::Vector{Vector{Int}},
    z2::Vector{Int},
    maps,
) where {F<:Function}
    for i in eachindex(output)
        _operate_exponents_to!(output[i], op, z1[i], z2, maps)
    end
    return
end
# Not used yet
#function _operate_exponents!(op::F, Z::Vector{Vector{Int}}, z2::Vector{Int}, args::Vararg{Any,N}) where {F<:Function,N}
#    return Vector{Int}[_operate_exponents!(op, z, z2, args...) for z in Z]
#end
function _resize!(output::Vector, n)
    return resize!(output, n)
end
function _resize!(output::Vector{<:Vector}, n)
    for out in output
        _resize!(out, n)
    end
end
function _multdivmono!(
    output,
    output_variables::Vector{Variable{V,M}},
    v::Vector{Variable{V,M}},
    x::Monomial{V,M},
    op,
    z,
) where {V<:Commutative,M}
    if v == x.vars
        if output_variables != v
            resize!(output_variables, length(v))
            copyto!(output_variables, v)
            _resize!(output, length(output_variables))
        end
        _operate_exponents_to!(output, op, z, x.z)
    else
        maps = mergevars_to!(output_variables, [v, x.vars])
        _resize!(output, length(output_variables))
        _operate_exponents_to!(output, op, z, x.z, maps)
    end
    return
end
function _operate_exponents(
    op::F,
    z1::Vector{Int},
    z2::Vector{Int},
) where {F<:Function}
    return op.(z1, z2)
end
function _operate_exponents(
    op::F,
    z1::Vector{Int},
    z2::Vector{Int},
    n,
    maps,
) where {F<:Function}
    newz = zeros(Int, n)
    I = maps[1]
    i = 1
    lI = length(I)
    J = maps[2]
    j = 1
    lJ = length(J)
    while i <= lI || j <= lJ
        if i > lI || (j <= lJ && J[j] < I[i])
            newz[J[j]] = op(0, z2[j])
            j += 1
        elseif j > lJ || (i <= lI && I[i] < J[j])
            newz[I[i]] = op(z1[i], 0)
            i += 1
        else
            @assert I[i] == J[j]
            newz[I[i]] = op(z1[i], z2[j])
            i += 1
            j += 1
        end
    end
    return newz
end
function _operate_exponents(
    op::F,
    Z::Vector{Vector{Int}},
    z2::Vector{Int},
    args::Vararg{Any,N},
) where {F<:Function,N}
    return Vector{Int}[_operate_exponents(op, z, z2, args...) for z in Z]
end
function multdivmono(
    v::Vector{Variable{V,M}},
    x::Monomial{V,M},
    op,
    z,
) where {V<:Commutative,M}
    if v == x.vars
        w = copy(v)
        z_new = _operate_exponents(op, z, x.z)
    else
        w, maps = mergevars([v, x.vars])
        z_new = _operate_exponents(op, z, x.z, length(w), maps)
    end
    return w, z_new
end
function MP.map_exponents_to!(
    output::Monomial{V},
    f::Function,
    x::Monomial{V},
    y::Monomial{V},
) where {V<:Commutative}
    if x.vars == y.vars
        if output.vars != x.vars
            n = length(x.vars)
            resize!(output.vars, n)
            copyto!(output.vars, x.vars)
            resize!(output.z, n)
        end
        _operate_exponents_to!(output.z, f, x.z, y.z)
    else
        _multdivmono!(output.z, output.vars, x.vars, y, f, x.z)
    end
    return output
end
function MP.map_exponents!(
    f::Function,
    x::Monomial{V},
    y::Monomial{V},
) where {V<:Commutative}
    if x.vars == y.vars
        _operate_exponents_to!(x.z, f, x.z, y.z)
    else
        _multdivmono!(x.z, x.vars, copy(x.vars), y, f, copy(x.z))
    end
    return x
end
function MP.map_exponents(
    f::Function,
    x::Monomial{V,M},
    y::Monomial{V,M},
) where {V<:Commutative,M}
    w, z = multdivmono(x.vars, y, f, x.z)
    return Monomial{V,M}(w, z)
end
function MP.map_exponents(
    f::Function,
    x::MonomialVector{V},
    y::Monomial{V},
) where {V<:Commutative}
    w, Z = multdivmono(x.vars, y, f, x.Z)
    return MonomialVector(w, Z)
end
function MP.map_exponents!(
    f::Function,
    x::MonomialVector{V},
    y::Monomial{V},
) where {V<:Commutative}
    _multdivmono!(x.Z, x.vars, copy(x.vars), y, f, copy.(x.Z))
    return x
end
function MP.map_exponents(
    f::Function,
    x::MonomialVector{V},
    y::Variable{V},
) where {V<:Commutative}
    return MP.map_exponents(f, x, MP.monomial(y))
end
function MP.map_exponents!(
    f::Function,
    x::MonomialVector{V},
    y::Variable{V},
) where {V<:Commutative}
    return MP.map_exponents!(f, x, MP.monomial(y))
end
function MA.operate!(
    ::typeof(*),
    x::MonomialVector{V},
    y::DMonomialLike{V},
) where {V<:Commutative}
    return MP.map_exponents!(+, x, y)
end
function Base.:(*)(
    y::MonomialVector{V},
    x::DMonomialLike{V},
) where {V<:Commutative}
    return MP.map_exponents(+, y, x)
end
function Base.:(*)(
    x::DMonomialLike{V},
    y::MonomialVector{V},
) where {V<:Commutative}
    return y * x
end
Base.:(*)(x::Monomial{V}, y::Variable{V}) where {V<:Commutative} = y * x

module DynamicPolynomials

import Future # For `copy!`

using Reexport
@reexport using MultivariatePolynomials
import MultivariatePolynomials as MP

import MutableArithmetics as MA

include("var.jl")
#const CommutativeVariable{O,M} = Variable{Commutative{O},M}
#const NonCommutativeVariable{O,M} = Variable{NonCommutative{O},M}
include("mono.jl")
const DMonomialLike{V,M} = Union{Monomial{V,M},Variable{V,M}}
MA.mutability(::Type{<:Monomial{<:Commutative}}) = MA.IsMutable()
MA.mutability(::Type{<:Monomial{<:NonCommutative}}) = MA.IsNotMutable()
const _Term{V,M,T} = MP.Term{T,Monomial{V,M}}
function __add_variables!(t::_Term, allvars, map)
    return __add_variables!(MP.monomial(t), allvars, map)
end
include("monomial_vector.jl")
include("poly.jl")
MA.mutability(::Type{<:Polynomial}) = MA.IsMutable()
const TermPoly{V,M,T} = Union{_Term{V,M,T},Polynomial{V,M,T}}
const PolyType{V,M} =
    Union{Polynomial{V,M},_Term{V,M},Monomial{V,M},Variable{V,M}}
function MP.variable_union_type(
    ::Union{PolyType{V,M},Type{<:PolyType{V,M}}},
) where {V,M}
    return Variable{V,M}
end
MP.constant_monomial(::Type{<:PolyType{V,M}}) where {V,M} = Monomial{V,M}()
function MP.constant_monomial(p::PolyType)
    return Monomial(copy(MP.variables(p)), zeros(Int, nvariables(p)))
end
MP.monomial_type(::Type{<:PolyType{V,M}}) where {V,M} = Monomial{V,M}
MP.monomial_type(::PolyType{V,M}) where {V,M} = Monomial{V,M}
MP.ordering(p::PolyType) = MP.ordering(MP.variable_union_type(p))
#function MP.constant_monomial(::Type{Monomial{V,M}}, vars=Variable{V,M}[]) where {V,M}
#    return Monomial{V,M}(vars, zeros(Int, length(vars)))
#end
function MP.term_type(
    ::Union{TermPoly{V,M,T},Type{<:TermPoly{V,M,T}}},
) where {V,M,T}
    return _Term{V,M,T}
end
function MP.term_type(
    ::Union{PolyType{V,M},Type{<:PolyType{V,M}}},
    ::Type{T},
) where {V,M,T}
    return _Term{V,M,T}
end
MP.term_type(::Type{Polynomial{V,M}}) where {V,M} = _Term{V,M}
MP.polynomial_type(::Type{_Term{V,M}}) where {V,M} = Polynomial{V,M}
MP.polynomial_type(::Type{_Term{V,M,T}}) where {T,V,M} = Polynomial{V,M,T}
function MP.polynomial_type(
    ::Union{PolyType{V,M},Type{<:PolyType{V,M}}},
    ::Type{T},
) where {V,M,T}
    return Polynomial{V,M,T}
end
MP.variables(p::AbstractArray{<:PolyType}) = mergevars(MP.variables.(p))[1]
function MP.nvariables(
    p::Union{PolyType,MonomialVector,AbstractArray{<:PolyType}},
)
    return length(MP.variables(p))
end
function MP.similar_variable(
    P::Union{PolyType{V,M},Type{<:PolyType{V,M}}},
    ::Type{Val{S}},
) where {V,M,S}
    return MP.similar_variable(P, S)
end
function MP.similar_variable(p::PolyType{V,M}, s::Symbol) where {V,M}
    return Variable(string(s), V, M, isreal(p) ? REAL : COMPLEX)
end
function MP.similar_variable(::Type{<:PolyType{V,M}}, s::Symbol) where {V,M}
    return Variable(string(s), V, M, REAL) # we cannot infer this from the type
end

include("promote.jl")

include("operators.jl")
include("comp.jl")

include("anti_diff.jl")
include("diff.jl")
include("subs.jl")

include("div.jl")

end # module

# We don't export `Monomial` to avoid a clash with `MultivariateBases.Monomial`
# export Monomial

const TupOrVec{T} = Union{AbstractVector{T},Tuple{Vararg{T}}}

# Invariant:
# vars is increasing
# z may contain 0's (otherwise, getindex of MonomialVector would be inefficient)
struct Monomial{V,M} <: AbstractMonomial
    vars::Vector{Variable{V,M}}
    z::Vector{Int}

    function Monomial{V,M}(
        vars::Vector{Variable{V,M}},
        z::Vector{Int},
    ) where {V,M}
        if length(vars) != length(z)
            throw(
                ArgumentError("There should be as many variables as exponents"),
            )
        end
        return new(vars, z)
    end
end

function Monomial{V,M}(
    vars::Tuple{Vararg{Variable{V,M}}},
    z::Vector{Int},
) where {V,M}
    return Monomial{V,M}([vars...], z)
end

function MP.monomial(vars::Vector{Variable{V,M}}, z::Vector{Int}) where {V,M}
    # TODO need a sanity check for the noncommutative case as well
    @assert !iscomm(V) || issorted(vars, rev = true)
    return Monomial{V,M}(vars, z)
end

MP.is_commutative(::Type{<:Monomial{V}}) where {V} = iscomm(V)
Monomial{V,M}() where {V,M} = Monomial{V,M}(Variable{V,M}[], Int[])
function Monomial(vars::TupOrVec{Variable{V,M}}, z::Vector{Int}) where {V,M}
    return Monomial{V,M}(vars, z)
end
function Base.convert(::Type{Monomial{V,M}}, x::Variable{V,M}) where {V,M}
    return Monomial{V,M}([x], [1])
end
Monomial(x::Variable{V,M}) where {V,M} = convert(Monomial{V,M}, x)
function MP.convert_constant(::Type{Monomial{V,M}}, α) where {V,M}
    isone(α) ||
        error("Cannot convert `$α` to a `Monomial{$V,$M}` as it is not one")
    return Monomial{V,M}(Variable{V,M}[], Int[])
end

# defaults to commutative so that `Monomial(1)` is consistent with TypedPolynomials
function Monomial(α::Number)
    return convert(Monomial{Commutative{CreationOrder},Graded{LexOrder}}, α)
end

Base.broadcastable(m::Monomial) = Ref(m)
MA.mutable_copy(m::M) where {M<:Monomial} = M(copy(m.vars), copy(m.z))
Base.copy(m::Monomial) = MA.mutable_copy(m)

function MA.operate!(::typeof(constant_monomial), mono::Monomial)
    MA.operate!(zero, mono.z)
    return mono
end

# Generate canonical reperesentation by removing variables that are not used
function canonical(m::Monomial)
    list = m.z .> 0
    return Monomial(MP.variables(m)[list], m.z[list])
end
function Base.hash(x::Monomial, u::UInt)
    cx = canonical(x)
    if iszero(nvariables(cx))
        hash(1, u)
    elseif nvariables(cx) == 1 && cx.z[1] == 1
        hash(cx.vars[1], u)
    else # TODO reduce power in MP
        hash(MP.variables(cx), hash(cx.z, u))
    end
end

MP.exponents(m::Monomial) = m.z
# /!\ vars not copied, do not mess with vars
MP.variables(m::Union{Monomial}) = m.vars

function MP.exponents(mono::Monomial{<:NonCommutative}, vars::AbstractVector)
    allvars, maps = mergevars([MP.variables(mono), vars])
    @assert allvars == vars
    z = zeros(Int, length(allvars))
    z[maps[1]] = MP.exponents(mono)
    return z
end

# Does m1 divides m2 ?
#function MP.divides(m1::Monomial, m2::Monomial)
#    i = j = 1
#    while i <= length(m1.z) && j <= length(m2.z)
#        if m1.vars[i] == m2.vars[j]
#            if m1.z[i] > m2.z[j]
#                return false
#            end
#            i += 1
#            j += 1
#        elseif m1.vars[i] > m2.vars[j]
#            if !iszero(m1.z[i])
#                return false
#            end
#            i += 1
#        else
#            j += 1
#        end
#    end
#    i > length(m1.z)
#end

function __add_variables!(
    mono::Monomial{V,M},
    allvars::Vector{Variable{V,M}},
    map,
) where {V,M}
    copy!(mono.vars, allvars)
    tmp = copy(mono.z)
    resize!(mono.z, length(allvars))
    fill!(mono.z, 0)
    mono.z[map] = tmp
    return
end

# for efficiency reasons
function Base.conj(x::Monomial{V,M}) where {V<:Commutative,M}
    cv = conj.(x.vars)
    perm = sortperm(cv, rev = true)
    return Monomial{V,M}(cv[perm], x.z[perm])
end

using Test
import MultivariatePolynomials as MP

@testset "Variable and Monomial tests" begin
    @testset "Variable macro index set" begin
        n = 3
        @polyvar x[1:n] y z[1:n-1] u[1:n, 1:n-1]
        VT = typeof(y)
        @test x isa Vector{VT}
        @test y isa VT
        @test z isa Vector{VT}
        @test u isa Matrix{VT}
        @test length(x) == 3
        @test length(z) == 2
        @test size(u) == (3, 2)
        @test x[1] > x[2] > x[3] > y > z[1] > z[2]
        @test u[1, 1] > u[2, 1] > u[2, 2]
        dummy = VT("dummy")
        @test dummy isa VT
        @test name(dummy) == "dummy"

        @polyvar a[1:5, 1:3, 1:2]
        @test size(a) == (5, 3, 2)
    end
    @testset "Variable macro tuple return" begin
        vars = @polyvar x y z
        @test vars isa Tuple
        @test vars == (x, y, z)

        vars = @ncpolyvar x y z
        @test vars isa Tuple
        @test vars == (x, y, z)
    end

    @testset "variable_union_type" begin
        @polyvar x
        XT = typeof(x)
        @test DynamicPolynomials.MP.variable_union_type(x) == XT
        @test DynamicPolynomials.MP.variable_union_type(x^2) == XT
        @test DynamicPolynomials.MP.variable_union_type(2x) == XT
        @test DynamicPolynomials.MP.variable_union_type(x + 1) == XT
        @ncpolyvar y
        YT = typeof(y)
        @test DynamicPolynomials.MP.variable_union_type(y) == YT
        @test DynamicPolynomials.MP.variable_union_type(y^2) == YT
        @test DynamicPolynomials.MP.variable_union_type(2y) == YT
        @test DynamicPolynomials.MP.variable_union_type(y + 1) == YT
    end
    @testset "Variable" begin
        @polyvar x
        XT = typeof(x)
        @test zero_term(XT) == 0
        @test zero(XT) == 0
        @ncpolyvar y
        YT = typeof(y)
        @test one(YT) == 1
        @polyvar x
        @test zero_term(x) isa MP.Term{Int,monomial_type(XT)}
        @test zero(x) isa polynomial_type(XT)
        @test one(x) isa monomial_type(XT)
    end
    @testset "Monomial" begin
        @ncpolyvar ncp
        YT = typeof(ncp)
        @test zero_term(YT) == 0
        @test zero(YT) == 0
        @polyvar cp
        XT = typeof(cp)
        @test one(XT) == 1
        @test_throws ErrorException DynamicPolynomials.Monomial(2)
        @test (@inferred DynamicPolynomials.Monomial(1)) isa monomial_type(XT)
        @test DynamicPolynomials.Monomial(1) == 1
        @test_throws ErrorException convert(monomial_type(XT), 2)
        @test (@inferred convert(monomial_type(XT), 1)) isa monomial_type(XT)
        @test convert(monomial_type(XT), 1) == 1
        @test_throws ErrorException convert(monomial_type(YT), 2)
        @test (@inferred convert(monomial_type(YT), 1)) isa monomial_type(YT)
        @test convert(monomial_type(YT), 1) == 1
        @polyvar x
        @test_throws ArgumentError monomial_type(XT)([x], [1, 0])
        @test zero_term(x^2) isa MP.Term{Int,monomial_type(x)}
        @test zero(x^2) isa polynomial_type(XT)
        @test one(x^2) isa monomial_type(XT)

        @polyvar y
        @test DynamicPolynomials.Monomial([x, y], [1, 0]) == x
        @test x != DynamicPolynomials.Monomial([x, y], [0, 1])
    end
    @testset "MonomialVector" begin
        @polyvar x y
        @test_throws AssertionError monomial_vector_type(x)([x], [[1], [1, 0]])
        X = MonomialVector([x, 1, x * y])
        @test variables(X) == [x, y]
        @test X.Z == [[0, 0], [1, 0], [1, 1]]
        @test monomial_vector_type(x)([1]) isa monomial_vector_type(x)
        @ncpolyvar nc
        @test monomial_vector_type(nc)([1]) isa monomial_vector_type(nc)
        a = [1, 5, 3]
        b, Y = monomial_vector(a, X)
        @test b === a
        @test Y === X
        σ, Y = sort_monomial_vector(X)
        @test σ == 1:length(X)
        @test Y === X
        XX = @inferred merge_monomial_vectors([X, X])
        @test XX isa monomial_vector_type(x)
        @test X == XX

        @test 2 != MonomialVector([x, y], 1)
        @test x != MonomialVector([x, y], 1)
        @test MonomialVector([x, y], [[0, 0], [1, 0]]) ==
              MonomialVector([x], [[0], [1]])
    end
    @testset "Non-commutative" begin
        @ncpolyvar x
        @test_throws ArgumentError monomial_type(x)([x], [1, 0])
        @test_throws AssertionError monomial_vector_type(x)([x], [[1], [1, 0]])
    end
    @testset "NC Variable * Monomial" begin
        @ncpolyvar x y z
        m = y * DynamicPolynomials.Monomial([y, z, x, z], [0, 0, 2, 1])
        @test variables(m) == [y, z, x, z]
        @test m.z == [1, 0, 2, 1]
        m = x * DynamicPolynomials.Monomial([z, y, y, z], [0, 0, 2, 1])
        @test variables(m) == [z, x, y, y, z]
        @test m.z == [0, 1, 0, 2, 1]
        m = x * DynamicPolynomials.Monomial([y, z, y, z], [0, 0, 2, 1])
        @test variables(m) == [y, z, x, y, z]
        @test m.z == [0, 0, 1, 2, 1]
    end
    @testset "NC Monomial * Variable" begin
        @ncpolyvar x y z
        m = DynamicPolynomials.Monomial([x, z, x, y], [2, 1, 0, 0]) * y
        @test variables(m) == [x, z, x, y]
        @test m.z == [2, 1, 0, 1]
        m = DynamicPolynomials.Monomial([x, y, y, x], [2, 1, 0, 0]) * z
        @test variables(m) == [x, y, y, z, x]
        @test m.z == [2, 1, 0, 1, 0]
        m = MP.monomial([x, y, x, y], [2, 1, 0, 0]) * z
        @test variables(m) == [x, y, z, x, y]
        @test m.z == [2, 1, 1, 0, 0]
    end

    @testset "Antidifferentiation" begin
	      @ncpolyvar x y z

        m = x
        mi = DynamicPolynomials.MP.antidifferentiate(m, y)
        @test mi == x * y

        # Antidifferentiation is product => Integral coefficients
        @test MP.coefficient_type(mi) == Int

        # General antidifferentiation => Rational coefficients
        m = x^3
        mi = DynamicPolynomials.MP.antidifferentiate(m, x)
        @test mi == (x^4 / 4)
        @test MP.coefficient_type(mi) == Rational{Int}

        m = DynamicPolynomials.Monomial([x, y, z], [1, 2, 3])
        mi = DynamicPolynomials.MP.antidifferentiate(m, z)
        @test mi == (x*y^2*z^4) / 4
        @test MP.coefficient_type(mi) == Rational{Int}
    end

    @testset "Evaluation" begin
        @polyvar x y
        @test (x^2 * y)(3, 2) == 18
        @test (x^2 * y)((3, 2)) == 18
        @test (x^2 * y)([3, 2]) == 18
        @test (x^2)(3) == 9
        @test (x)(3) == 3
    end
    @testset "TODO remove when added to MP" begin
        @polyvar x y
        @test x == DynamicPolynomials.MP.map_exponents!(div, x^1, x * y^2)
        for z in [x * y, x^2, y^2]
            @test y ==
                  DynamicPolynomials.MP.map_exponents_to!(z, -, x * y^2, x * y)
        end
    end
    # TODO add to MP
    @testset "Indexing with boolean" begin
        @polyvar x y
        X = monomials([x, y], 2)
        @test X[[true, false, true]] == monomial_vector([x^2, y^2])
        X = monomials([x, y], 0:1)
        @test filter(mono -> degree(mono) == 1, X) == monomial_vector([x, y])
        @test filter(mono -> degree(mono) == 0, X) == monomial_vector([x^0])
    end
    @testset "NC exponents with variables" begin
        @ncpolyvar x y z
        # Monomial with subset of variables, exponents mapped to full variable list
        m = DynamicPolynomials.Monomial([x, z], [2, 3])
        e = MP.exponents(m, [x, y, z])
        @test e == [2, 0, 3]
        @test length(e) == 3

        # Single variable monomial mapped to larger variable set
        m = DynamicPolynomials.Monomial([y], [4])
        e = MP.exponents(m, [x, y, z])
        @test e == [0, 4, 0]

        # Monomial using all variables
        m = DynamicPolynomials.Monomial([x, y, z], [1, 2, 3])
        e = MP.exponents(m, [x, y, z])
        @test e == [1, 2, 3]

        # Constant monomial (no variables)
        m = DynamicPolynomials.Monomial(typeof(x)[], Int[])
        e = MP.exponents(m, [x, y, z])
        @test e == [0, 0, 0]

        # Noncommutative monomial with repeated variables
        m = DynamicPolynomials.Monomial([x, y, x], [1, 2, 3])
        e = MP.exponents(m, [x, y, x])
        @test e == [1, 2, 3]
    end
    @testset "Noncommutative div" begin
        @ncpolyvar x y
	err = ErrorException("Not implemented yet")
	@test_throws err div(x, x * y)
    end
end

@testset "Term and Polynomial tests" begin
    @testset "Term" begin
        @polyvar x
        TT = term_type(x)
        TTF = term_type(x, Float64)
        PT = polynomial_type(TT)
        PTF = polynomial_type(TTF)
        @ncpolyvar y
        NCTT = term_type(y)
        #       @test coefficient_type(1x) == Int
        #       @test coefficient_type(1.0x^2) == Float64
        #       @test coefficient_type(Term{true, Int}) == Int
        @test MP.coefficient(zero_term(NCTT)) == 0
        @test MP.coefficient(one(TT)) == 1
        @test typeof(MP.term(1x)) == TT
        @test MP.term(1x) == 1x
        @test typeof(convert(Any, 1x)) == TT
        @test typeof(one(1x)) == TT
        @test typeof(zero_term(1x)) == TT
        @test typeof(zero(1x)) == PT
        @test typeof(one(1.0x)) == TTF
        @test typeof(zero_term(1.0x)) == TTF
        @test typeof(zero(1.0x)) == PTF

        @test typeof(constant_term(1, x)) == TT
        @inferred constant_term(1, x)
        @test typeof(polynomial(1:2, monomials([x], 1:2))) == PT
    end

    @testset "Polynomial" begin
        #@test eltype(polynomial{true, Int}) == Int
        @polyvar x
        TT = term_type(x)
        PT = polynomial_type(x)
        @test_throws ArgumentError PT([1, 2], [x])
        @test_throws ArgumentError PT([1, 2], MonomialVector([x]))
        @test_throws InexactError PT([1.5], [x])
        @test polynomial(1 + x) == 1 + x
        @test typeof(one(1 + x)) == PT
        @test typeof(zero_term(1 + x)) == TT
        @test typeof(zero(1 + x)) == PT
        TTF = term_type(x, Float64)
        PTF = polynomial_type(x, Float64)
        @test typeof(one(1.0 + x)) == PTF
        @test typeof(zero_term(1.0 + x)) == TTF
        @test typeof(zero(1.0 + x)) == PTF

        pf = DynamicPolynomials.Polynomial(i -> 1.0, [x * x, x, x * x])
        @test coefficients(pf) == [1.0, 2.0]
        @test monomials(pf) == monomial_vector([x^2, x])

        p = polynomial([4, 9], [x, x * x])
        p.a == [9, 4]
        p.x[1] == x^2
        p.x[2] == x

        @inferred DynamicPolynomials.Polynomial(i -> float(i), [x, x * x])
        @inferred DynamicPolynomials.Polynomial(
            i -> float(i),
            MonomialVector([x * x, x]),
        )
        for p in (
            DynamicPolynomials.Polynomial(i -> float(i), [x, x * x]),
            DynamicPolynomials.Polynomial(
                i -> float(i),
                MonomialVector([x * x, x]),
            ),
        )
            @test typeof(p) == PTF
            @test p.a == [1.0, 2.0]
            @test p.x == MonomialVector([x^2, x])
        end

        @ncpolyvar ncpolyvar u v
        NCPT = polynomial_type(u)
        @inferred DynamicPolynomials.Polynomial(i -> i, [u, u * u, 1])
        p = DynamicPolynomials.Polynomial(i -> i, [u, u * u, 1])
        @test typeof(p) == NCPT
        @test p.a == [3, 1, 2]
        @test p.x == MonomialVector([u^2, u, 1])

        @test u + v * u + 1 != v * u + u
        @test remove_monomials(u + v * u + 1, [1, u * v]) == v * u + u
        @test remove_monomials(u + u * v + 1, [u * v]) == 1 + u

        @inferred polynomial(2u)
        @inferred polynomial(2.0u, Int)
    end

    @testset "Antiderivative" begin
        @polyvar x y

        p = (x^2 + 4 * y^3)
        @test MP.coefficient_type(p) == Int

        pi = DynamicPolynomials.antidifferentiate(p, y)
        @test pi == (x^2 * y + y^4)

        pi = DynamicPolynomials.antidifferentiate(p, x)
        @test MP.coefficient_type(pi) == Rational{Int}

        p = (1.0 * x^2 + 2.0 * y^2)
        @test MP.coefficient_type(p) == Float64

        pi = DynamicPolynomials.antidifferentiate(p, x)
        @test MP.coefficient_type(pi) == Float64

        p = 2 * y
        pi = DynamicPolynomials.antidifferentiate(p, y)
        @test pi == y^2

        p = x^2
        pi = DynamicPolynomials.antidifferentiate(p, y)
        @test pi == x^2 * y

    end

    @testset "Evaluation" begin
        @polyvar x y
        @test (x^2 + y^3)(2, 3) == 31
        @test (x^2 + y^3)((2, 3)) == 31
        @test (x^2 + y^3)([2, 3]) == 31
        @test (2x^2 * y)(3, 2) == 36
        @test (2x^2 * y)((3, 2)) == 36
        @test (2x^2 * y)([3, 2]) == 36
        @test (2x^2)(3) == 18
        err = ArgumentError(
            "Variable `y` was not assigned a value. Use `subs` to substitute only a subset of the variables.",
        )
        t = 2x^2 * y
        @test_throws err t(x => 1)
        p = 2x^2 + y
        @test_throws err p(x => 1)
        err = ArgumentError(
            "Variable `x` was not assigned a value. Use `subs` to substitute only a subset of the variables.",
        )
        @test_throws err t(y => 1)
        @test_throws err p(y => 1)

        @complex_polyvar z
        pc = z^3 + 2real(z) - 7imag(z^4)
        @test pc(z => 2 + 3im) == 798 + 9im
        err = ArgumentError(
            "Substitution with complex variables requires the ordinary_variable in the substitution specification"
        )
        @test_throws err pc(conj(z) => 2 - 3im)
        @test_throws err pc(real(z) => 2)
        @test_throws err pc(imag(z) => 3)
        @test real(pc)(z => 2 + 3im) == 798
    end
end

function MP.promote_variables(m1::Monomial, m2::Monomial)
    if MP.variables(m1) == MP.variables(m2)
        return m1, m2
    end
    allvars, maps = mergevars([MP.variables(m1), MP.variables(m2)])
    z1 = zeros(Int, length(allvars))
    z1[maps[1]] = m1.z
    z2 = zeros(Int, length(allvars))
    z2[maps[2]] = m2.z
    return Monomial(allvars, z1), Monomial(allvars, z2)
end

# StarAlgebras promote_with_map implementations
# These are called by SA.maybe_promote(p, all_vars, map) when map is an ExponentMap,
# as part of SA.promote_bases_with_maps (defined in MultivariatePolynomials.jl).
# Guarded by isdefined since ExponentMap is not yet in released MultivariatePolynomials.

function SA.promote_with_map(
    v::Variable{V,M},
    all_vars::Vector{Variable{V,M}},
    map::MP.ExponentMap,
) where {V,M}
    new_z = map([1])
    return Monomial{V,M}(copy(all_vars), new_z), map
end

function SA.promote_with_map(
    m::Monomial{V,M},
    all_vars::Vector{Variable{V,M}},
    map::MP.ExponentMap,
) where {V,M}
    return Monomial{V,M}(copy(all_vars), map(m.z)), map
end

function SA.promote_with_map(
    p::Polynomial{V,M,T},
    all_vars::Vector{Variable{V,M}},
    map::MP.ExponentMap,
) where {V,M,T}
    new_Z = [map(z) for z in p.x.Z]
    new_x = MonomialVector{V,M}(copy(all_vars), new_Z)
    return Polynomial{V,M,T}(copy(p.a), new_x), map
end

function MP.promote_rule_constant(
    ::Type{T},
    ::Type{<:DMonomialLike{V,M}},
) where {V,M,T}
    return _Term{V,M,promote_type(T, Int)}
end
function MP.promote_rule_constant(
    ::Type{S},
    ::Type{_Term{V,M,T}},
) where {S,V,M,T}
    return _Term{V,M,promote_type(S, T)}
end
function MP.promote_rule_constant(
    ::Type{S},
    ::Type{<:TermPoly{V,M,T}},
) where {S,V,M,T}
    return Polynomial{V,M,promote_type(S, T)}
end
MP.promote_rule_constant(::Type, ::Type{_Term{V,M}}) where {V,M} = Any
MP.promote_rule_constant(::Type, ::Type{Polynomial{V,M}}) where {V,M} = Any
function Base.promote_rule(
    ::Type{_Term{V,M}},
    ::Type{_Term{V,M,T}},
) where {V,M,T}
    return _Term{V,M}
end
function Base.promote_rule(
    ::Type{_Term{V,M,T}},
    ::Type{_Term{V,M}},
) where {V,M,T}
    return _Term{V,M}
end
function Base.promote_rule(
    ::Type{_Term{V,M}},
    ::Type{<:DMonomialLike{V,M}},
) where {V,M}
    return _Term{V,M}
end
function Base.promote_rule(
    ::Type{<:DMonomialLike{V,M}},
    ::Type{_Term{V,M}},
) where {V,M}
    return _Term{V,M}
end

function Base.convert(::Type{_Term{V,M}}, m::DMonomialLike{V,M}) where {V,M}
    return convert(_Term{V,M,Int}, m)
end
function Base.convert(
    ::Type{Polynomial{V,M}},
    t::Union{TermPoly{V,M},DMonomialLike{V,M}},
) where {V,M}
    return MP.polynomial(t)
end

using DynamicPolynomials
using MultivariatePolynomials
using Test
using LinearAlgebra

function alloc_test_lt(f, n)
    f() # compile
    @test n >= @allocated f()
end

# TODO move to MP
@testset "See https://github.com/jump-dev/SumOfSquares.jl/issues/388" begin
    @polyvar x[1:3]
    p = sum(x)
    v = map(_ -> 1, x)
    # I get 208 but let's give some margin
    alloc_test_lt(() -> substitute(Eval(), p, x => v), 300)
    alloc_test_lt(() -> p(x => v), 300)
    alloc_test_lt(() -> substitute(Eval(), p, v), 0)
    alloc_test_lt(() -> p(v), 0)
    err = ErrorException("Cannot evaluate a polynomial of `3` variables with only `2` values.")
    @test_throws err p([1, 2])
end

@testset "Issue #70" begin
    @ncpolyvar y0 y1 x0 x1
    p = x1 * x0 * x1
    @test subs(p, x0 => y0, x1 => y1) == y1 * y0 * y1
    @test subs(p, x0 => 1) == x1^2
    @test p(x0 => y0, x1 => y1) == y1 * y0 * y1
end

# https://github.com/JuliaAlgebra/DynamicPolynomials.jl/issues/141
@testset "Issue #141" begin
    @polyvar x
    m = x^2
    q = m^2
    @test variables(q) !== variables(m)
end

@testset "Issue #79, Issue #80 and Issue #92" begin
    @polyvar x[1:2]
    p1 = x[1] * 0.0 + x[2] * 0
    p2 = (x[1] + x[2]) * 0.0
    @test variables(p1) == x
    @test variables(p1) == variables(p2)

    @polyvar χ[1:4]
    poly_array_int = [1 0 1 0; 0 1 0 1] * χ
    poly_array_float = Float64.([1 0 1 0; 0 1 0 1]) * χ

    vars_array_int = variables.(poly_array_int)
    vars_array_float = variables.(poly_array_float)
    @test isa(vars_array_int, Vector{<:Vector{<:Variable}})
    @test isa(vars_array_float, Vector{<:Vector{<:Variable}})
    @test vars_array_int == vars_array_float
    @test vars_array_int[1] == vars_array_float[2] == χ

    # This is for Issue #92
    p3 = subs(p1, x => x)
    @test variables(p3) == x

    p4 = x[1] + x[2]
    @test variables(subs(p4, x[2] => 1)) == [x[1]]
    @test variables(subs(p4, x[1] => 1)) == [x[2]]
end

include("mono.jl")
include("poly.jl")
include("comp.jl")
include("mutable_arithmetics.jl")

module newmodule
using Test
import DynamicPolynomials
@testset "Polyvar macro hygiene" begin
    # Verify that the @polyvar macro works when the package has been activated
    # with `import` instead of `using`.
    DynamicPolynomials.@polyvar x y
    @test isa(x, DynamicPolynomials.Variable)
    @test isa(y, DynamicPolynomials.Variable)
end
end

include("mvp.jl")

function Base.:(*)(
    x::Variable{V,M},
    y::Variable{V,M},
) where {V<:NonCommutative,M}
    if x === y
        Monomial{V,M}([x], [2])
    else
        Monomial{V,M}([x, y], [1, 1])
    end
end

function multiplyvar(
    v::Vector{Variable{V,M}},
    z::Vector{Int},
    x::Variable{V,M},
) where {V,M}
    i = length(v)
    while i > 0 && z[i] == 0
        i -= 1
    end
    if i > 0 && v[i] == x
        return copy(v), multiplyexistingvar(i, z)
    else
        #   ---->
        # \  |\  |\
        #  \ | \ | \
        #   \|  \|  \
        # If v[i] > x, we wait either for a rise (v[i] > v[i-1]) or v[i] < x
        # Otherwise, we first wait for a drop and then wait for the same thing
        ndrop = 0
        if i > 0 && v[i] > x
            droplim1 = 0
            droplim2 = 1
        else
            droplim1 = 1
            droplim2 = 2
        end
        i += 1
        while i <= length(v) && v[i] != x
            if i > 1 && v[i] > v[i-1]
                ndrop += 1
            end
            if ndrop >= droplim2 || (ndrop >= droplim1 && v[i] < x)
                break
            end
            i += 1
        end

        if i <= length(v) && v[i] == x
            return copy(v), multiplyexistingvar(i, z)
        else
            return insertvar(v, x, i), insertvar(z, x, i)
        end
    end
end
function multiplyvar(
    x::Variable{<:NonCommutative},
    v::Vector{<:Variable{<:NonCommutative}},
    z::Vector{Int},
)
    i = 1
    while i <= length(v) && z[i] == 0
        i += 1
    end
    if i <= length(v) && v[i] == x
        return copy(v), multiplyexistingvar(i, z)
    else
        #   <----
        # \  |\  |\
        #  \ | \ | \
        #   \|  \|  \
        # If z[i] < x, we wait either for a drop (v[i] < v[i+1]) or v[i] > x
        # Otherwise, we first wait for a drop and then wait for the same thing
        ndrop = 0
        if i <= length(v) && v[i] < x
            droplim1 = 0
            droplim2 = 1
        else
            droplim1 = 1
            droplim2 = 2
        end
        i -= 1
        while i > 0 && v[i] != x
            if i < length(v) && v[i] < v[i+1]
                ndrop += 1
            end
            if ndrop >= droplim2 || (ndrop >= droplim1 && v[i] > x)
                break
            end
            i -= 1
        end
        if i > 0 && v[i] == x
            return copy(v), multiplyexistingvar(i, z)
        else
            return insertvar(v, x, i + 1), insertvar(z, x, i + 1)
        end
    end
end
function Base.:(*)(x::Variable{<:NonCommutative}, y::Monomial{<:NonCommutative})
    w, z = multiplyvar(x, y.vars, y.z)
    return Monomial(w, z)
end
function Base.:(*)(y::Monomial{<:NonCommutative}, x::Variable{<:NonCommutative})
    w, z = multiplyvar(y.vars, y.z, x)
    return Monomial(w, z)
end

function Base.:(*)(
    x::Monomial{V,M},
    y::Monomial{V,M},
) where {V<:NonCommutative,M}
    i = findlast(z -> z > 0, x.z)
    if i === nothing || i == 0
        return y
    end
    j = findfirst(z -> z > 0, y.z)
    if j === nothing || j == 0
        return x
    end
    if x.vars[i] == y.vars[j]
        w = [x.vars[1:i]; y.vars[j+1:end]]
        z = [x.z[1:i-1]; x.z[i] + y.z[j]; y.z[j+1:end]]
    else
        w = [x.vars[1:i]; y.vars[j:end]]
        z = [x.z[1:i]; y.z[j:end]]
    end
    return Monomial(w, z)
end

function Base.:(*)(
    y::MonomialVector{V,M},
    x::DMonomialLike{V,M},
) where {V<:NonCommutative,M}
    return MonomialVector{V,M}([yi * x for yi in y])
end
function Base.:(*)(
    x::DMonomialLike{V,M},
    y::MonomialVector{V,M},
) where {V<:NonCommutative,M}
    # The order may change
    # Example: y * [x^2, y^2] == [y^3, yx^2]
    return MonomialVector{V,M}([x * yi for yi in y])
end

# Invariant:
# a and x might be empty: meaning it is the zero polynomial
# a does not contain any zeros
# x is increasing in the monomial order (i.e. grlex)
struct Polynomial{V,M,T} <: AbstractPolynomial{T}
    a::Vector{T}
    x::MonomialVector{V,M}

    function Polynomial{V,M,T}(
        a::Vector{T},
        x::MonomialVector{V,M},
    ) where {V,M,T}
        length(a) == length(x) || throw(
            ArgumentError("There should be as many coefficient than monomials"),
        )
        p = new{V,M,T}(a, x)
        _remove_zeros!(p)
        return p
    end
end
function Polynomial{V,M,T}(terms::AbstractVector{<:_Term{V,M}}) where {V,M,T}
    a = T[coefficient(t) for t in terms]
    monos = Monomial{V,M}[monomial(t) for t in terms]
    allvars, Z = buildZvarsvec(Variable{V,M}, monos)
    x = MonomialVector{V,M}(allvars, Z)
    return Polynomial{V,M,T}(a, x)
end

MP.is_commutative(::Type{Polynomial{V,M,T}}) where {V,M,T} = iscomm(V)

function _zero_with_variables(
    ::Type{Polynomial{V,M,T}},
    vars::Vector{Variable{V,M}},
) where {V,M,T}
    return Polynomial(T[], MonomialVector{V,M}(vars, Vector{Int}[]))
end

Base.broadcastable(p::Polynomial) = Ref(p)
function MA.mutable_copy(p::Polynomial{V,M,T}) where {V,M,T}
    return Polynomial{V,M,T}(MA.mutable_copy(p.a), MA.mutable_copy(p.x))
end
Base.copy(p::Polynomial) = MA.mutable_copy(p)
function Base.zero(::Type{Polynomial{V,M,T}}) where {V,M,T}
    return Polynomial(T[], MonomialVector{V,M}())
end
function Base.one(::Type{Polynomial{V,M,T}}) where {V,M,T}
    return Polynomial([one(T)], MonomialVector{V,M}(Variable{V,M}[], [Int[]]))
end
function Base.zero(p::Polynomial{V,M,T}) where {V,M,T}
    return Polynomial(T[], empty_monomial_vector(copy(MP.variables(p))))
end
function Base.one(p::Polynomial{V,M,T}) where {V,M,T}
    return Polynomial(
        [one(T)],
        MonomialVector(copy(MP.variables(p)), [zeros(Int, nvariables(p))]),
    )
end

function Polynomial{V,M,T}(a::AbstractVector, x::MonomialVector) where {V,M,T}
    return Polynomial{V,M,T}(Vector{T}(a), x)
end
function Polynomial{V,M,T}(a::AbstractVector, X::DMonoVec) where {V,M,T}
    return Polynomial{V,M,T}(monomial_vector(a, X)...)
end
Polynomial{V,M}(a::Vector{T}, x) where {V,M,T} = Polynomial{V,M,T}(a, x)
function Polynomial(af::Union{Function,Vector}, x::DMonoVec{V,M}) where {V,M}
    return Polynomial{V,M}(af, x)
end

# This is called by the default implementation of `Base.oneunit`, still in Julia v1.8 at least
Polynomial{V,M,T}(p::Polynomial{V,M,T}) where {V,M,T} = p

Base.convert(::Type{Polynomial{V,M,T}}, p::Polynomial{V,M,T}) where {V,M,T} = p
function Base.convert(
    ::Type{Polynomial{V,M,T}},
    t::AbstractTermLike,
) where {V,M,T}
    if iszero(t)
        _zero_with_variables(Polynomial{V,M,T}, variables(t))
    else
        # `exponents(::Variable)` gives a tuple
        return Polynomial{V,M,T}(
            [coefficient(t)],
            MonomialVector{V,M}(variables(t), [_vec(exponents(t))]),
        )
    end
end
function Base.convert(
    ::Type{Polynomial{V,M,T}},
    p::AbstractPolynomialLike,
) where {V,M,T}
    return Polynomial{V,M,T}(terms(p))
end

function Polynomial{V,M}(
    p::Union{Polynomial{V,M},_Term{V,M},Monomial{V,M},Variable{V,M}},
) where {V,M}
    return Polynomial(p)
end
Polynomial{V,M}(α) where {V,M} = Polynomial(_Term{V,M}(α))

Polynomial(p::Polynomial) = p
function Polynomial(t::_Term{V,M,T}) where {V,M,T}
    return convert(Polynomial{V,M,T}, mutable_copy(t))
end
function Polynomial(x::Union{Variable{V,M},Monomial{V,M}}) where {V,M}
    return Polynomial(_Term{V,M}(x))
end

#Base.convert(::Type{TermContainer{V,M,T}}, p::Polynomial{V,M}) where {V,M,T} = Polynomial{V,M,T}(p)

function Polynomial{V,M,T}(f::Function, x::MonomialVector{V,M}) where {V,M,T}
    a = T[f(i) for i in 1:length(x)]
    return Polynomial{V,M,T}(a, x)
end
function Polynomial{V,M,T}(f::Function, x::AbstractVector) where {V,M,T}
    σ, X = sort_monomial_vector(x)
    a = T[f(i) for i in σ]
    if length(x) > length(X)
        rev = Dict(X[j] => j for j in eachindex(σ))
        for i in eachindex(x)
            j = rev[x[i]]
            if i != σ[j]
                a[j] += f(i)
            end
        end
    end
    return Polynomial{V,M,T}(a, X)
end
function Polynomial{V,M}(f::Function, x) where {V,M}
    return Polynomial{V,M,Base.promote_op(f, Int)}(f, x)
end

#Base.convert(::Type{PolyType{V,M}}, p::TermContainer{V,M}) where {V,M} = p

# needed to build [p Q; Q p] where p is a polynomial and Q is a matpolynomial in Julia v0.5
#Base.convert(::Type{term_type{V,M}}, p::TermContainer{V,M}) where {V,M} = p
#Base.convert(::Type{term_type{V,M,T}}, p::TermContainer{V,M,T}) where {V,M,T} = p


#Base.transpose(p::Polynomial) = Polynomial(map(transpose, p.a), p.x) # FIXME invalid age range update

struct TermIterator{V,M,T} <: AbstractVector{_Term{V,M,T}}
    p::Polynomial{V,M,T}
end
Base.firstindex(p::TermIterator) = firstindex(p.p.a)
Base.lastindex(p::TermIterator) = lastindex(p.p.a)
Base.length(p::TermIterator) = length(p.p.a)
Base.size(p::TermIterator) = (length(p),)
Base.isempty(p::TermIterator) = isempty(p.p.a)
Base.iterate(p::TermIterator) = isempty(p) ? nothing : (p[1], 1)
function Base.iterate(p::TermIterator, state::Int)
    return state < length(p) ? (p[state+1], state + 1) : nothing
end

Base.getindex(p::TermIterator, I::Int) = MP.term(p.p.a[I[1]], p.p.x[I[1]])

MP.terms(p::Polynomial) = TermIterator(p)
MP.coefficients(p::Polynomial) = p.a
MP.monomials(p::Polynomial) = p.x
MP.variables(p::Polynomial) = MP.variables(p.x)

MP.extdegree(p::Polynomial) = extdegree(p.x)
MP.mindegree(p::Polynomial) = mindegree(p.x)
MP.maxdegree(p::Polynomial) = maxdegree(p.x)

function MP.leading_coefficient(p::Polynomial{V,M,T}) where {V,M,T}
    return iszero(p) ? zero(T) : last(p.a)
end
function MP.leading_monomial(p::Polynomial)
    return iszero(p) ? constant_monomial(p) : last(p.x)
end
MP.leading_term(p::Polynomial) = iszero(p) ? zero_term(p) : last(terms(p))

function MP.remove_leading_term(p::Polynomial)
    return Polynomial(p.a[1:end-1], p.x[1:end-1])
end
function MA.operate!(::typeof(MP.remove_leading_term), p::Polynomial)
    pop!(p.a)
    pop!(p.x)
    return p
end
function MP.remove_monomials(p::Polynomial, x::MonomialVector)
    # use the fact that monomials are sorted to do this O(n) instead of O(n^2)
    j = 1
    I = Int[]
    for (i, t) in enumerate(MP.terms(p))
        while j <= length(x) && x[j] < MP.monomial(t)
            j += 1
        end
        if j > length(x) || x[j] != MP.monomial(t)
            push!(I, i)
        end
    end
    return Polynomial(p.a[I], p.x[I])
end
function MP.remove_monomials(p::Polynomial, x::Vector)
    return remove_monomials(p, MonomialVector(x))
end

function _remove_zeros!(p::Polynomial)
    zeroidx = Int[]
    for (i, α) in enumerate(p.a)
        if iszero(α)
            push!(zeroidx, i)
        end
    end
    if !isempty(zeroidx)
        deleteat!(p.a, zeroidx)
        deleteat!(p.x.Z, zeroidx)
    end
end

function removedups_to!(
    a::Vector{T},
    Z::Vector{Vector{Int}},
    adup::Vector{T},
    Zdup::Vector{Vector{Int}},
    ::Type{M},
) where {T,M}
    _isless = let M = M
        (a, b) -> cmp(M(), a, b) < 0
    end
    σ = sortperm(Zdup, lt = _isless)
    i = 0
    j = 1
    while j <= length(adup)
        k = σ[j]
        if j == 1 || Zdup[k] != Zdup[σ[j-1]]
            push!(Z, Zdup[k])
            push!(a, adup[k])
            i += 1
        else
            a[i] = MA.operate!!(+, a[i], adup[k])
        end
        j += 1
    end
end
function polynomialclean(
    vars::Vector{Variable{V,M}},
    adup::Vector{T},
    Zdup::Vector{Vector{Int}},
) where {V,M,T}
    Z = Vector{Int}[]
    a = T[]
    removedups_to!(a, Z, adup, Zdup, M)
    return Polynomial{V,M,T}(a, MonomialVector{V,M}(vars, Z))
end
function polynomialclean_to!(
    p::Polynomial{V,M,T},
    vars::Vector{Variable{V,M}},
    adup::Vector{T},
    Zdup::Vector{Vector{Int}},
) where {V,M,T}
    copy!(p.x.vars, vars)
    empty!(p.a)
    empty!(p.x.Z)
    removedups_to!(p.a, p.x.Z, adup, Zdup, M)
    _remove_zeros!(p)
    return p
end

function MP.polynomial!(a::Vector, x::DMonoVec, ::MP.ListState)
    return Polynomial(a, x)
end
function MP.polynomial(a::AbstractVector, x::DMonoVec, s::MP.ListState)
    return MP.polynomial!(collect(a), MA.mutable_copy(x), s)
end

#MP.polynomial(f::Function, x::AbstractVector) = Polynomial(f, x)
#MP.polynomial(ts::AbstractVector{Term{V,M,T}}) where {V,M,T} = Polynomial(coefficient.(ts), monomial.(ts)) # FIXME invalid age range update

# i < j
function trimap(i, j, n)
    return div(n * (n + 1), 2) - div((n - i + 1) * (n - i + 2), 2) + j - i + 1
end
function MP.polynomial(Q::AbstractMatrix{T}, mv::MonomialVector) where {T}
    return MP.polynomial(Q, mv, Base.promote_op(+, T, T))
end
function MP.polynomial(
    Q::AbstractMatrix,
    mv::MonomialVector{V,M},
    ::Type{T},
) where {V,M,T}
    if isempty(Q)
        zero(Polynomial{V,M,T})
    else
        n = length(mv)
        if V <: Commutative
            N = trimap(n, n, n)
            Z = Vector{Vector{Int}}(undef, N)
            a = Vector{T}(undef, N)
            for i in 1:n
                for j in i:n
                    k = trimap(i, j, n)
                    Z[k] = mv.Z[i] + mv.Z[j]
                    if i == j
                        a[k] = Q[i, j]
                    else
                        a[k] = Q[i, j] + Q[j, i]
                    end
                end
            end
            v = MP.variables(mv)
        else
            N = n^2
            x = Vector{Monomial{V,M}}(undef, N)
            a = Vector{T}(undef, N)
            offset = 0
            for i in 1:n
                # for j in 1:n wouldn't be cache friendly for Q
                for j in i:n
                    k = trimap(i, j, n)
                    x[offset+k] = mv[i] * mv[j]
                    a[offset+k] = Q[i, j]
                    if i != j
                        offset += 1
                        x[offset+k] = mv[j] * mv[i]
                        a[offset+k] = Q[j, i]
                    end
                end
            end
            a, X = monomial_vector(a, x)
            v = MP.variables(X)
            Z = X.Z
        end
        polynomialclean(v, a, Z)
    end
end

function MA.operate!(::typeof(zero), p::Polynomial)
    empty!(p.a)
    empty!(p.x.Z)
    return p
end
function MA.operate!(::typeof(one), p::Polynomial{V,M,T}) where {V,M,T}
    if isempty(p.a)
        push!(p.a, one(T))
        push!(p.x.Z, zeros(Int, length(p.x.vars)))
    else
        resize!(p.a, 1)
        p.a[1] = MA.operate!!(one, p.a[1])
        resize!(p.x.Z, 1)
        MA.operate!(zero, p.x.Z[1])
    end
    return p
end

function MP.map_coefficients(f::Function, p::Polynomial; nonzero = false)
    return Polynomial(map(f, p.a), MA.mutable_copy(p.x))
end

function MP.map_coefficients!(f::Function, p::Polynomial; nonzero = false)
    map!(f, p.a, p.a)
    if !nonzero
        _remove_zeros!(p)
    end
    return p
end

function MP.map_coefficients_to!(
    output::Polynomial,
    f::Function,
    t::MP.AbstractTermLike;
    nonzero = false,
)
    return MP.map_coefficients_to!(output, f, polynomial(t); nonzero = nonzero)
end
function MP.map_coefficients_to!(
    output::Polynomial,
    f::Function,
    p::Polynomial;
    nonzero = false,
)
    resize!(output.a, length(p.a))
    map!(f, output.a, p.a)
    copy!(output.x.vars, p.x.vars)
    # TODO reuse the part of `Z` that is already in `output`.
    resize!(output.x.Z, length(p.x.Z))
    for i in eachindex(p.x.Z)
        output.x.Z[i] = copy(p.x.Z[i])
    end
    if !nonzero
        _remove_zeros!(output)
    end
    return output
end

function MP.map_exponents(f::Function, p::Polynomial, m::DMonomialLike)
    return Polynomial(MA.mutable_copy(p.a), MP.map_exponents(f, p.x, m))
end

function MP.map_exponents!(f::Function, p::Polynomial, m::DMonomialLike)
    MP.map_exponents!(f, p.x, m)
    return p
end

function __add_variables!(p::Polynomial, allvars, map)
    return __add_variables!(p.x, allvars, map)
end

using Test

import MutableArithmetics
const MA = MutableArithmetics
import MultivariatePolynomials as MP

using DynamicPolynomials

@testset "Mutable Arithmetics with $T" for T in [Int, BigInt]
    @polyvar x y z
    p = T(2)x^2 + T(4)y^2
    q = T(3)x * y
    @test p === MA.add!!(p, q)
    @test q == T(3)x * y
    @test nterms(p) == 3
    @test issorted(monomials(p))
    @test p == T(2)x^2 + T(3)x * y + T(4)y^2
    @test p === MA.add!!(p, x * y)
    @test nterms(p) == 3
    @test issorted(monomials(p))
    @test p == T(2)x^2 + T(4)x * y + T(4)y^2
    @test p === MA.add!!(p, T(2)x^3 + T(3)x^2 + T(5)x + T(2))
    @test nterms(p) == 6
    @test issorted(monomials(p))
    @test p == T(2)x^3 + T(5)x^2 + T(4)x * y + T(4)y^2 + T(5)x + T(2)
    q = T(5)z^3 + T(1)x * z + T(4)z^2 + T(3)z
    @test p === MA.add!!(p, q)
    @test nterms(p) == 10
    @test issorted(monomials(p))
    @test p == T(2)x^3 + T(5)x^2 + T(4)x * y + T(4)y^2 + T(5)x + T(2) + q

    @testset "Issue #62" begin
        @polyvar x y
        p = x^2 + x + 1
        q = rem(p, [x^2 - y])
        @test q == x + y + 1
    end
end

@testset "Fast path cases: $ord" for ord in [
        InverseLexOrder,
        LexOrder,
        Graded{InverseLexOrder},
        Graded{LexOrder},
        Reverse{InverseLexOrder},
        Reverse{LexOrder},
        Graded{Reverse{InverseLexOrder}},
        Graded{Reverse{LexOrder}},
        Reverse{Graded{InverseLexOrder}},
        Reverse{Graded{LexOrder}},
    ]
    @polyvar x y z monomial_order=ord

    # allocation tests vary between Julia versions, so they're upper bounds
    @testset "Polynomial + constant" begin
        poly = 2 * x^2 + 3 * x * y + z * y^2
        poly2 = copy(poly)
        result = poly + 2
        MA.operate!(+, poly, 2)
        @test isequal(poly, result)
        # down from 576 using the generic method
        @test (@allocated MA.operate!(+, poly2, 2)) <= 272
        # subsequent additions don't allocate
        @test (@allocated MA.operate!(+, poly2, 2)) == 0

        # also test `-`
        poly = 2 * x^2 + 3 * x * y + z * y^2
        poly2 = copy(poly)
        result = poly - 2
        MA.operate!(-, poly, 2)
        @test isequal(poly, result)
        # down from 576 using the generic method
        @test (@allocated MA.operate!(-, poly2, 2)) <= 272
        # subsequent additions don't allocate
        @test (@allocated MA.operate!(-, poly2, 2)) == 0
    end

    @testset "Polynomial + Variable" begin
        poly = 2 * x^2 + 3 * x * y + z * y^2
        poly2 = copy(poly)
        result = poly + x
        MA.operate!(+, poly, x)
        @test isequal(poly, result)
        # down from 18752 using the generic method
        # 368 or 304 depending on ordering, more for different version
        # pre is especially bad
        @test (@allocated MA.operate!(+, poly2, x)) <= 400
        # down from 1904 using the generic method
        @test (@allocated MA.operate!(+, poly2, x)) <= 144

        # also test `-`
        poly = 2 * x^2 + 3 * x * y + z * y^2
        poly2 = copy(poly)
        result = poly - x
        MA.operate!(-, poly, x)
        @test isequal(poly, result)
        # down from 18752 using the generic method
        # 368 or 304 depending on ordering
        @test (@allocated MA.operate!(-, poly2, x)) <= 400
        # down from 1904 using the generic method
        @test (@allocated MA.operate!(-, poly2, x)) <= 144
    end
end

@testset "Non-concrete in-place polynomial addition" begin
    @polyvar p q r s
    p1 = MP.polynomial(r - q, Number) + MP.polynomial(3//5 * p^2, Number)
    p2 = MP.polynomial(1//2 + s, Number) + MP.polynomial(p^2, Number)
    result = p1 + p2
    @test isequal(result, MA.operate!(+, p1, p2))

    p1 = MP.polynomial(r - q, Number) + MP.polynomial(3//5 * p^2, Number)
    p2 = MP.polynomial(1//2 + s, Number) + MP.polynomial(p^2, Number)
    @test isequal(result, MA.operate!(+, p2, p1))
end

import MultivariatePolynomials
const mvp_test =
    joinpath(dirname(pathof(MultivariatePolynomials)), "..", "test")
const Mod = DynamicPolynomials
const MP = MultivariatePolynomials
include(joinpath(mvp_test, "utils.jl"))
include(joinpath(mvp_test, "commutativetests.jl"))
include(joinpath(mvp_test, "noncommutativetests.jl"))

# In Base/intfuncs.jl, x^p returns zero(x) when p == 0
# Since one(Variable) and one(Monomial) do not return
# a Variable and a Monomial, this results in type instability
# Defining the specific methods solve this problem and also make
# them a lot faster
Base.:(^)(x::Variable{V,M}, i::Int) where {V,M} = Monomial{V,M}([x], [i])
Base.:(^)(x::Monomial{<:Commutative}, i::Int) = Monomial(copy(x.vars), i * x.z)

Base.:(+)(x::DMonomialLike, y::DMonomialLike) = MP.term(x) + MP.term(y)
Base.:(-)(x::DMonomialLike, y::DMonomialLike) = MP.term(x) - MP.term(y)

_getindex(p::Polynomial, i::Int) = MP.terms(p)[i]
_getindex(t::_Term, ::Int) = t
function _plusorminus_to!(
    a::Vector{U},
    Z::Vector{Vector{Int}},
    op::Function,
    p::TermPoly{V,M},
    q::TermPoly{V,M},
    maps,
    nvars,
) where {V,M,U}
    i = j = 1
    while i <= nterms(p) || j <= nterms(q)
        z = zeros(Int, nvars)
        if j > nterms(q) || (
            i <= nterms(p) &&
            MP.monomial(_getindex(p, i)) < MP.monomial(_getindex(q, j))
        )
            t = _getindex(p, i)
            z[maps[1]] = MP.monomial(t).z
            α = MA.scaling_convert(U, MA.copy_if_mutable(MP.coefficient(t)))
            i += 1
        elseif i > nterms(p) ||
               MP.monomial(_getindex(q, j)) < MP.monomial(_getindex(p, i))
            t = _getindex(q, j)
            z[maps[2]] = MP.monomial(t).z
            α = MA.scaling_convert(U, MA.operate(op, MP.coefficient(t)))
            j += 1
        else
            t = _getindex(p, i)
            z[maps[1]] = MP.monomial(t).z
            s = _getindex(q, j)
            α = op(MP.coefficient(t), MP.coefficient(s))
            i += 1
            j += 1
        end
        push!(a, α)
        push!(Z, z)
    end
end
function plusorminus(
    p::TermPoly{V,M,S},
    q::TermPoly{V,M,T},
    op::Function,
) where {V,M,S,T}
    varsvec = [MP.variables(p), MP.variables(q)]
    allvars, maps = mergevars(varsvec)
    U = MA.promote_operation(op, S, T)
    a = U[]
    Z = Vector{Int}[]
    _plusorminus_to!(a, Z, op, p, q, maps, length(allvars))
    return Polynomial(a, MonomialVector{V,M}(allvars, Z))
end

function MA.operate!(::typeof(*), p::Polynomial, t::_Term)
    # In case `coefficient(t)` is a polynomial (e.g. in `gcd` algorithm)
    # We cannot do `MA.operate!(*, ...)`, we need `MP.right_constant_mult`
    MA.operate!(MP.right_constant_mult, p, coefficient(t))
    MA.operate!(*, p, monomial(t))
    return p
end

function MA.operate_to!(
    output::Polynomial{V,M},
    op::Union{typeof(+),typeof(-)},
    p::TermPoly{V,M},
    q::TermPoly{V,M},
) where {V,M}
    if output === p || output === q
        # Otherwise, `_plusorminus_to!` never finishes
        error(
            "Cannot call `operate_to!(output, $op, p, q)` with `output` equal to `p` or `q`, call `operate!` instead.",
        )
    end
    varsvec = [MP.variables(p), MP.variables(q)]
    allvars, maps = mergevars(varsvec)
    Future.copy!(output.x.vars, allvars)
    empty!(output.a)
    empty!(output.x.Z)
    _plusorminus_to!(output.a, output.x.Z, op, p, q, maps, length(allvars))
    return output
end

function MA.operate!(
    op::Union{typeof(+),typeof(-)},
    p::Polynomial,
    q::Union{Variable,Monomial,_Term},
)
    return MA.operate!(op, p, polynomial(q))
end
const _NoVarTerm{T} = Tuple{T,Vector{Int}}
function MA.operate!(
    op::Union{typeof(+),typeof(-)},
    p::Polynomial{<:NonCommutative},
    q::Polynomial{<:NonCommutative},
)
    return MA.operate_to!(p, op, MA.copy(p), q)
end

function _exponents_compare(q::Polynomial{V,M}, j, e) where {V,M}
    return cmp(M(), q.x.Z[j], e)
end

# TODO need to check that this also works for non-commutative
function MA.operate!(
    op::Union{typeof(+),typeof(-)},
    p::Polynomial{V},
    q::Polynomial{V},
) where {V<:Commutative}
    if MP.variables(p) != MP.variables(q)
        allvars, maps = ___add_variables!(p, q)
        if length(allvars) == length(MP.variables(q))
            rhs = q
        else
            # We could avoid promoting `q` to the same variables
            # like in `plusorminus` to avoid extra allocation but it then
            # gives slower comparison. There is a tradeoff and the approach used here
            # should be better of `q` has less terms and then the same term is compared
            # many times.
            rhs = Polynomial(q.a, copy(q.x))
            __add_variables!(rhs, allvars, maps[2])
        end
        return MA.operate!(op, p, rhs)
    end
    get1(i) = (p.a[i], p.x.Z[i])
    function get2(i)
        return (
            MA.scaling_convert(eltype(p.a), MA.operate(op, q.a[i])),
            copy(q.x.Z[i]),
        )
    end
    function set(i, t::_NoVarTerm)
        p.a[i] = t[1]
        return p.x.Z[i] = t[2]
    end
    function push(t::_NoVarTerm)
        push!(p.a, t[1])
        return push!(p.x.Z, t[2])
    end
    compare_monomials_impl(t, j) = _exponents_compare(q, j, t[2])
    compare_monomials(t::_NoVarTerm, j::Int) = compare_monomials_impl(t, j)
    compare_monomials(i::Int, j::Int) = compare_monomials_impl(get1(i), j)
    combine(i::Int, j::Int) = p.a[i] = MA.operate!!(op, p.a[i], q.a[j])
    combine(t::_NoVarTerm, j::Int) = (MA.operate!!(op, t[1], q.a[j]), t[2])
    function resize(n)
        resize!(p.a, n)
        return resize!(p.x.Z, n)
    end
    # We can modify the coefficient since it's the result of `combine`.
    keep(t::_NoVarTerm) = !MA.iszero!!(t[1])
    keep(i::Int) = !MA.iszero!!(p.a[i])
    MP.polynomial_merge!(
        nterms(p),
        nterms(q),
        get1,
        get2,
        set,
        push,
        compare_monomials,
        combine,
        keep,
        resize,
    )
    return p
end

Base.:(+)(x::TermPoly{V,M}, y::TermPoly{V,M}) where {V,M} = plusorminus(x, y, +)
Base.:(-)(x::TermPoly{V,M}, y::TermPoly{V,M}) where {V,M} = plusorminus(x, y, -)
function Base.:(+)(x::TermPoly{V,M}, y::Union{Monomial,Variable}) where {V,M}
    return x + MP.term(y)
end
function Base.:(+)(x::Union{Monomial,Variable}, y::TermPoly{V,M}) where {V,M}
    return MP.term(x) + y
end

function Base.:(-)(x::TermPoly{V,M,T}, y::DMonomialLike{V,M}) where {V,M,T}
    return x - convert(MP.term_type(y, T), y)
end
function Base.:(-)(x::DMonomialLike{V,M}, y::TermPoly{V,M,T}) where {V,M,T}
    return convert(MP.term_type(x, T), x) - y
end

# `MA.operate(-, p)` redirects to `-p` as it assumes that `-p` can be modified
# through the MA API without modifying `p`. We should either copy `p.x` here
# or implement a `MA.operate(-, p)` that copies it. We choose the first option.
Base.:(-)(p::Polynomial) = Polynomial(-p.a, copy(p.x))
# TODO use that with MA v0.2
#Base.:(-)(p::Polynomial) = Polynomial(map(α -> MA.operate(-, α), p.a), copy(p.x))

include("mult.jl")

function MP.differentiate(m::Monomial{V,M}, x::Variable{V,M}) where {V,M}
    i = findfirst(isequal(x), MP.variables(m))
    if (i === nothing || i == 0) || m.z[i] == 0
        zero_term(m)
    else
        z = copy(m.z)
        z[i] -= 1
        m.z[i] * Monomial(MP.variables(m), z)
    end
end

function MP.differentiate(p::Polynomial{V,M,T}, x::Variable{V,M}) where {V,M,T}
    # grlex order preserved
    i = something(findfirst(isequal(x), MP.variables(p)), 0)
    S = typeof(zero(T) * 0)
    if iszero(i)
        zero(Polynomial{V,M,S})
    else
        keep = findall(z -> z[i] > 0, p.x.Z)
        Z = copy.(p.x.Z[keep])
        a = Vector{S}(undef, length(keep))
        for j in 1:length(Z)
            a[j] = p.a[keep[j]] * Z[j][i]
            Z[j][i] -= 1
        end
        Polynomial(a, MonomialVector(MP.variables(p), Z))
    end
end

import Base.==

# TODO This should be in Base with T instead of Variable{V,M}.
# See https://github.com/blegat/MultivariatePolynomials.jl/issues/3
function Base.:(==)(x::Vector{Variable{V,M}}, y::Vector{Variable{V,M}}) where {V,M}
    if length(x) != length(y)
        false
    else
        #for (xi, yi) in zip(x, y)
        for i in 1:length(x)
            if x[i] != y[i]
                return false
            end
        end
        true
    end
end

# Comparison of Variable

const AnyCommutative{O} = Union{Commutative{O},NonCommutative{O}}

function Base.cmp(
    x::Variable{<:AnyCommutative{CreationOrder}},
    y::Variable{<:AnyCommutative{CreationOrder}},
)
    if x.variable_order.order.id == y.variable_order.order.id
        return cmp(y.kind, x.kind)
    else
        return cmp(y.variable_order.order.id, x.variable_order.order.id)
    end
end

# TODO remove
Base.:(==)(x::Variable, y::Variable) = iszero(cmp(x, y))
Base.:(==)(x::Monomial, y::Monomial) = iszero(cmp(x, y))

# Comparison of MonomialVector
function (==)(x::MonomialVector{V,M}, y::MonomialVector{V,M}) where {V,M}
    if length(x.Z) != length(y.Z)
        return false
    end
    allvars, maps = mergevars([MP.variables(x), MP.variables(y)])
    # Should be sorted in the same order since the non-common
    # polyvar should have exponent 0
    for (a, b) in zip(x.Z, y.Z)
        A = zeros(Int, length(allvars))
        B = zeros(Int, length(allvars))
        A[maps[1]] = a
        B[maps[2]] = b
        if A != B
            return false
        end
    end
    return true
end
(==)(mv::AbstractVector, x::MonomialVector) = monomial_vector(mv) == x
(==)(x::MonomialVector, mv::AbstractVector) = x == monomial_vector(mv)

# Comparison of Term
function _compare(p::Polynomial{V,M}, q::Polynomial{V,M}, comparator) where {V,M}
    # terms should be sorted and without zeros
    if MP.nterms(p) != MP.nterms(q)
        return false
    end
    for i in eachindex(p.a)
        if !comparator(p.x[i], q.x[i])
            # There should not be zero terms
            @assert p.a[i] != 0
            @assert q.a[i] != 0
            return false
        end
        if !comparator(p.a[i], q.a[i])
            return false
        end
    end
    return true
end

(==)(p::Polynomial{V, M}, q::Polynomial{V, M}) where {V, M} = _compare(p, q, (==))
Base.isequal(p::Polynomial{V, M}, q::Polynomial{V, M}) where {V, M} = _compare(p, q, isequal)

function Base.isapprox(
    p::Polynomial{V,M,S},
    q::Polynomial{V,M,T};
    rtol::Real = Base.rtoldefault(S, T, 0),
    atol::Real = 0,
    ztol::Real = iszero(atol) ? Base.rtoldefault(S, T, 0) : atol,
) where {V,M,S,T}
    i = j = 1
    while i <= length(p.x) || j <= length(q.x)
        if i > length(p.x) || (j <= length(q.x) && q.x[j] < p.x[i])
            if !isapproxzero(q.a[j], ztol = ztol)
                return false
            end
            j += 1
        elseif j > length(q.x) || p.x[i] < q.x[j]
            if !isapproxzero(p.a[i], ztol = ztol)
                return false
            end
            i += 1
        else
            if !isapprox(p.a[i], q.a[j], rtol = rtol, atol = atol)
                return false
            end
            i += 1
            j += 1
        end
    end
    return true
end

using Test
using DynamicPolynomials
import DynamicPolynomials: Commutative, CreationOrder # to test hygiene
@testset "Variable order" begin
    @polyvar x
    z = x
    @polyvar x
    @test z != x
    order = Commutative{CreationOrder}
    @polyvar x variable_order = order
    @test z != x
end
function _less(a, b)
    @test a < b
    @test b > a
    @test cmp(monomial(a), b) < 0
    @test cmp(b, monomial(a)) > 0
end
@testset "Issue 152" begin
    @polyvar x y monomial_order=LexOrder
    _less(x, x * y)
    _less(x * y^2, x^2)
end
@testset "README example" begin
    function p(x, y, z)
        return sprint(
            show,
            MIME"text/plain"(),
            4x * y^2 * z + 4z^2 - 5x^3 + 7x^2 * z^2,
        )
    end
    @polyvar x y z monomial_order = LexOrder
    @test p(x, y, z) == "4z² + 4xy²z + 7x²z² - 5x³"
    @polyvar x y z
    @test p(x, y, z) == "4z² - 5x³ + 4xy²z + 7x²z²"
    @polyvar x y z monomial_order = Graded{Reverse{InverseLexOrder}}
    @test p(x, y, z) == "4z² - 5x³ + 7x²z² + 4xy²z"
end
# See https://github.com/JuliaAlgebra/DynamicPolynomials.jl/issues/138
# Also tests `ordering`
@testset "InverseLexOrder" begin
    order = Graded{InverseLexOrder}
    @polyvar x[1:2] monomial_order = order
    @test ordering(x[1]) == order
    @test issorted(monomials(x[1], 0:2))
end

function _test_less(a, b)
    @test a < b
    @test b > a
end

function _test_monomials(vars, degs, exp)
    # Without `collect`, `exp` is promoted to a `MonomialVector`
    # which sorts it so it doesn't test the order
    @test collect(monomials(vars, degs)) == exp
end

@testset "LexOrder" begin
    @polyvar x y monomial_order = LexOrder
    _test_less(y, y^2)
    _test_less(x^0, y)
    _test_less(y^2, x)
    _test_less(x * y^2, x^2)
    _test_monomials([x, y], 3, [y^3, y^2 * x, y * x^2, x^3])
    _test_monomials([x, y], 1:2, [y, y^2, x, x * y, x^2])
    _test_monomials([x, y], [0, 1, 3], [1, y, y^3, x, y^2 * x, y * x^2, x^3])
end

@testset "InverseLexOrder" begin
    @polyvar x y monomial_order = InverseLexOrder
    _test_less(y, y^2)
    _test_less(x^0, y)
    _test_less(x, y^2)
    _test_less(x^2, x * y^2)
    _test_monomials([x, y], 3, [x^3, x^2 * y, x * y^2, y^3])
end

@testset "Graded{Reverse{LexOrder}}" begin
    @polyvar x y monomial_order = Graded{Reverse{LexOrder}}
    _test_less(y, y^2)
    _test_less(x^0, y)
    _test_less(x, y^2)
    _test_less(x^2, x * y^2)
    _test_monomials([x, y], 3, [x^3, x^2 * y, x * y^2, y^3])
    _test_monomials([x, y], 1:2, [x, y, x^2, x * y, y^2])
    _test_monomials([x, y], [0, 1, 3], [1, x, y, x^3, x^2 * y, x * y^2, y^3])
end

@testset "Graded{Reverse{InverseLexOrder}}" begin
    @polyvar x y monomial_order = Graded{Reverse{InverseLexOrder}}
    _test_less(y, y^2)
    _test_less(x^0, y)
    _test_less(x, y^2)
    _test_less(x^2, x * y^2)
    _test_monomials([x, y], 3, [y^3, y^2 * x, y * x^2, x^3])
    _test_monomials([x, y], 1:2, [y, x, y^2, x * y, x^2])
    _test_monomials([x, y], [0, 1, 3], [1, y, x, y^3, x*y^2, x^2*y, x^3])
end

function _div_by_power(x::T, y::Int) where {T}
    x / y
end

function _div_by_power(x::T, y::Int)::Rational{T} where {T<:Integer}
    x // y
end

function MP.antidifferentiate(m::Monomial{V,M}, x::Variable{V,M}) where {V,M}
    z = copy(m.z)
    i = findfirst(isequal(x), MP.variables(m))
    if (i === nothing || i == 0) || m.z[i] == 0
        Monomial(MP.variables(m), z) * x
    else
        z[i] += 1
        (1 // (m.z[i] + 1)) * Monomial(MP.variables(m), z)
    end
end

function MP.antidifferentiate(p::Polynomial{V,M,T}, x::Variable{V,M}) where {V,M,T}
    i = something(findfirst(isequal(x), MP.variables(p)), 0)
    S = typeof(_div_by_power(zero(T), Int(1)))
    if iszero(i)
        x * p
    else
        Z = copy.(p.x.Z)
        a = Vector{S}(undef, length(p.a))
        for j in 1:length(Z)
            a[j] = _div_by_power(p.a[j], (Z[j][i] + 1))
            Z[j][i] += 1
        end
        Polynomial(a, MonomialVector(MP.variables(p), Z))
    end
end

export Variable, @polyvar, @ncpolyvar, @complex_polyvar

function polyarrayvar(
    variable_order,
    monomial_order,
    complex_kind,
    prefix,
    indices...,
)
    return map(
        i -> Variable(
            "$(prefix)[$(join(i, ","))]",
            variable_order,
            monomial_order,
            complex_kind,
        ),
        Iterators.product(indices...),
    )
end

function buildpolyvar(var, variable_order, monomial_order, complex_kind)
    if isa(var, Symbol)
        var,
        :(
            $(esc(var)) = $Variable(
                $"$var",
                $variable_order,
                $monomial_order,
                $complex_kind,
            )
        )
    else
        isa(var, Expr) || error("Expected $var to be a variable name")
        Base.Meta.isexpr(var, :ref) ||
            error("Expected $var to be of the form varname[idxset]")
        (2 ≤ length(var.args)) ||
            error("Expected $var to have at least one index set")
        varname = var.args[1]
        prefix = string(varname)
        varname,
        :(
            $(esc(varname)) = polyarrayvar(
                $(variable_order),
                $(monomial_order),
                $(complex_kind),
                $prefix,
                $(esc.(var.args[2:end])...),
            )
        )
    end
end

function buildpolyvars(args, variable_order, monomial_order, complex_kind)
    vars = Symbol[]
    exprs = []
    for arg in args
        var, expr =
            buildpolyvar(arg, variable_order, monomial_order, complex_kind)
        push!(vars, var)
        push!(exprs, expr)
    end
    return vars, exprs
end

# Inspired from `JuMP.Containers._extract_kw_args`
function _extract_kw_args(args, variable_order, complex_kind)
    positional_args = Any[]
    monomial_order = :($(MP.Graded{MP.LexOrder}))
    for arg in args
        if Base.Meta.isexpr(arg, :(=))
            if arg.args[1] == :variable_order
                variable_order = esc(arg.args[2])
            elseif arg.args[1] == :monomial_order
                monomial_order = esc(arg.args[2])
            elseif arg.args[1] == :complex
                complex_kind = arg.args[2] == :true ? COMPLEX : REAL
            else
                error("Unrecognized keyword argument `$(arg.args[1])`")
            end
        else
            push!(positional_args, arg)
        end
    end
    return positional_args, variable_order, monomial_order, complex_kind
end

# Variable vector x returned garanteed to be sorted so that if p is built with x then vars(p) == x
macro polyvar(args...)
    pos_args, variable_order, monomial_order, complex_kind =
        _extract_kw_args(args, :($(Commutative{CreationOrder})), REAL)
    vars, exprs =
        buildpolyvars(pos_args, variable_order, monomial_order, complex_kind)
    return :($(foldl((x, y) -> :($x; $y), exprs, init = :()));
    $(Expr(:tuple, esc.(vars)...)))
end

macro ncpolyvar(args...)
    pos_args, variable_order, monomial_order, complex_kind =
        _extract_kw_args(args, :($(NonCommutative{CreationOrder})), REAL)
    vars, exprs =
        buildpolyvars(pos_args, variable_order, monomial_order, complex_kind)
    return :($(foldl((x, y) -> :($x; $y), exprs, init = :()));
    $(Expr(:tuple, esc.(vars)...)))
end

macro complex_polyvar(args...)
    pos_args, variable_order, monomial_order, complex_kind =
        _extract_kw_args(args, :($(Commutative{CreationOrder})), COMPLEX)
    vars, exprs =
        buildpolyvars(pos_args, variable_order, monomial_order, complex_kind)
    return :($(foldl((x, y) -> :($x; $y), exprs, init = :()));
    $(Expr(:tuple, esc.(vars)...)))
end

abstract type AbstractVariableOrdering end

struct CreationOrder <: AbstractVariableOrdering
    id::Int
end

function instantiate(::Type{CreationOrder})
    # gensym returns something like Symbol("##42")
    # we first remove "##" and then parse it into an Int
    id = parse(Int, string(gensym())[3:end])
    return CreationOrder(id)
end

struct Commutative{O<:AbstractVariableOrdering} <: AbstractVariableOrdering
    order::O
end

iscomm(::Type{<:Commutative}) = false
function instantiate(::Type{Commutative{O}}) where {O}
    return Commutative(instantiate(O))
end

struct NonCommutative{O<:AbstractVariableOrdering} <: AbstractVariableOrdering
    order::O
end

iscomm(::Type{<:NonCommutative}) = false
function instantiate(::Type{NonCommutative{O}}) where {O}
    return NonCommutative(instantiate(O))
end

"""
    ComplexKind

The type used to identify whether a variable is complex-valued. It has the following instances:
- `REAL`: the variable is real-valued, [`conj`](@ref) and [`real`](@ref) are identities, [`imag`](@ref) is zero.
- `COMPLEX`: the variable is a declared complex-valued variable with distinct conjugate, real, and imaginary part.
  [`ordinary_variable`](@ref) is an identity.
- `CONJ`: the variable is the conjugate of a declared complex-valued variable. [`ordinary_variable`](@ref) is equal to
  [`conj`](@ref). It will print with an over-bar.
- `REAL_PART`: the variable is the real part of a complex-valued variable. It is real-valued itself: [`conj`](@ref) and
  [`real`](@ref) are identities, [`imag`](@ref) is zero. [`ordinary_variable`](@ref) will give back the original complex-valued
  _declared_ variable from which the real part was extracted. It will print with an `ᵣ` subscript.
- `IMAG_PART`: the variable is the imaginary part of a declared complex-valued variable (or the negative imaginary part of the
  conjugate of a declared complex-valued variable). It is real-valued itself: [`conj`](@ref) and [`real`](@ref) are identities,
  [`imag`](@ref) is zero. [`ordinary_variable`](@ref) will give back the original complex-valued _declared_ variable from which
  the imaginary part was extracted. It will print with an `ᵢ` subscript.
"""
@enum ComplexKind REAL COMPLEX CONJ REAL_PART IMAG_PART

struct Variable{V,M} <: AbstractVariable
    name::String
    kind::ComplexKind
    variable_order::V

    function Variable{V,M}(
        name::AbstractString,
        kind::ComplexKind = REAL,
    ) where {V<:AbstractVariableOrdering,M<:MP.AbstractMonomialOrdering}
        return new{V,M}(convert(String, name), kind, instantiate(V))
    end

    function Variable(
        name::AbstractString,
        ::Type{V},
        ::Type{M},
        kind::ComplexKind = REAL,
    ) where {V<:AbstractVariableOrdering,M<:MP.AbstractMonomialOrdering}
        return new{V,M}(convert(String, name), kind, instantiate(V))
    end

    function Variable(
        from::Variable{V,M},
        kind::ComplexKind,
    ) where {V<:AbstractVariableOrdering,M<:MP.AbstractMonomialOrdering}
        (from.kind == REAL && kind == REAL) ||
            (from.kind != REAL && kind != REAL) ||
            error("Cannot change the complex type of an existing variable")
        return new{V,M}(from.name, kind, from.variable_order)
    end
end

Base.hash(x::Variable, u::UInt) = hash(x.variable_order.order.id, u)
Base.broadcastable(x::Variable) = Ref(x)

MP.name(v::Variable) = v.name
function MP.name_base_indices(v::Variable)
    splits = split(v.name, r"[\[,\]]\s*", keepempty = false)
    if length(splits) == 1
        return v.name, Int[]
    else
        return splits[1], parse.(Int, splits[2:end])
    end
end

MP.monomial(v::Variable) = Monomial(v)
MP.variables(v::Variable) = [v]
MP.ordering(v::Variable) = MP.ordering(typeof(v))
MP.ordering(::Type{Variable{V,M}}) where {V,M} = M

iscomm(::Type{Variable{C}}) where {C} = C

Base.isreal(x::Variable{C}) where {C} = x.kind != COMPLEX && x.kind != CONJ
MP.isrealpart(x::Variable{C}) where {C} = x.kind == REAL_PART
MP.isimagpart(x::Variable{C}) where {C} = x.kind == IMAG_PART
MP.isconj(x::Variable{C}) where {C} = x.kind == CONJ
function MP.ordinary_variable(x::Variable)
    return x.kind == REAL || x.kind == COMPLEX ? x : Variable(x, COMPLEX)
end

function Base.conj(x::Variable)
    if x.kind == COMPLEX
        return Variable(x, CONJ)
    elseif x.kind == CONJ
        return Variable(x, COMPLEX)
    else
        return x
    end
end

function Base.real(x::Variable)
    if x.kind == COMPLEX || x.kind == CONJ
        return Variable(x, REAL_PART)
    else
        return x
    end
end
function Base.imag(x::Variable{V,M}) where {V,M}
    if x.kind == COMPLEX
        return Variable(x, IMAG_PART)
    elseif x.kind == CONJ
        return _Term{V,M,Int}(-1, Monomial(Variable(x, IMAG_PART)))
    else
        return MA.Zero()
    end
end

function mergevars_to!(
    vars::Vector{PV},
    varsvec::Vector{Vector{PV}},
) where {PV<:Variable}
    empty!(vars)
    n = length(varsvec)
    is = ones(Int, n)
    maps = zeros.(Int, length.(varsvec))
    nonempty = BitSet(findall(!isempty, varsvec))
    while !isempty(nonempty)
        imin = 0
        for i in nonempty
            if imin == 0 || varsvec[i][is[i]] > varsvec[imin][is[imin]]
                imin = i
            end
        end
        var = varsvec[imin][is[imin]]
        push!(vars, var)
        for i in nonempty
            if var == varsvec[i][is[i]]
                maps[i][is[i]] = length(vars)
                if is[i] == length(varsvec[i])
                    pop!(nonempty, i)
                else
                    is[i] += 1
                end
            end
        end
    end
    return maps
end
function mergevars(varsvec::Vector{Vector{PV}}) where {PV<:Variable}
    vars = PV[]
    maps = mergevars_to!(vars, varsvec)
    return vars, maps
end
function mergevars_of(::Type{Variable{V,M}}, polys::AbstractVector) where {V,M}
    varsvec =
        Vector{Variable{V,M}}[variables(p) for p in polys if p isa PolyType]
    # TODO avoid computing `maps`
    return mergevars(varsvec)
end

export MonomialVector

# Invariant: Always sorted and no zero vector
struct MonomialVector{V,M} <: AbstractVector{Monomial{V,M}}
    vars::Vector{Variable{V,M}}
    Z::Vector{Vector{Int}}

    function MonomialVector{V,M}(
        vars::Vector{Variable{V,M}},
        Z::Vector{Vector{Int}},
    ) where {V,M}
        @assert !iscomm(V) || issorted(vars, rev = true)
        @assert all(z -> length(z) == length(vars), Z)

        return new{V,M}(vars, Z)
    end
end
function MonomialVector(
    vars::Vector{Variable{V,M}},
    Z::Vector{Vector{Int}},
) where {V,M}
    return MonomialVector{V,M}(vars, Z)
end
function MonomialVector{V,M}() where {V,M}
    return MonomialVector{V,M}(Variable{V,M}[], Vector{Int}[])
end

# Generate canonical reperesentation by removing variables that are not used
function canonical(m::MonomialVector)
    v = zeros(Bool, nvariables(m))
    for z in m.Z
        v = [v[i] || z[i] > 0 for i in eachindex(v)]
    end
    return MonomialVector(MP.variables(m)[v], Vector{Int}[z[v] for z in m.Z])
end

function Base.hash(m::MonomialVector, u::UInt)
    cm = canonical(m)
    if length(cm.Z) == 0
        hash([], u)
    elseif length(cm.Z) == 1
        hash(Monomial(MP.variables(cm), cm.Z[1]), u)
    else
        hash(MP.variables(cm), hash(cm.Z, hash(u)))
    end
end

# vars copied as it may be modifed by `_add_variables!`
# `mutable_copy` recursively copies the vector or vector of integers.
function MA.mutable_copy(m::MV) where {MV<:MonomialVector}
    return MV(copy(m.vars), MA.mutable_copy(m.Z))
end
Base.copy(m::MonomialVector) = MA.mutable_copy(m)
function Base.getindex(x::MonomialVector, I::AbstractVector{Bool})
    return typeof(x)(x.vars, x.Z[I])
end
function Base.getindex(x::MonomialVector, I::AbstractVector{<:Integer})
    return typeof(x)(x.vars, x.Z[sort(I)])
end
Base.getindex(x::MonomialVector, i::Integer) = Monomial(x.vars, x.Z[i])
Base.getindex(x::MonomialVector, i::CartesianIndex{1}) = x[i.I[1]]

function Base.deleteat!(x::MonomialVector, i)
    deleteat!(x.Z, i)
    return x
end
function Base.pop!(x::MonomialVector)
    pop!(x.Z)
    return x
end

Base.firstindex(x::MonomialVector) = firstindex(x.Z)
Base.lastindex(x::MonomialVector) = lastindex(x.Z)
Base.size(x::MonomialVector) = (length(x),)
Base.length(x::MonomialVector) = length(x.Z)
Base.isempty(x::MonomialVector) = length(x) == 0
Base.iterate(x::MonomialVector) = isempty(x) ? nothing : (x[1], 1)
function Base.iterate(x::MonomialVector, state::Int)
    return state < length(x) ? (x[state+1], state + 1) : nothing
end

function MultivariatePolynomials.extdegree(x::MonomialVector)
    return isempty(x) ? (0, 0) : extrema(sum.(x.Z))
end
function MultivariatePolynomials.mindegree(x::MonomialVector)
    return isempty(x) ? 0 : minimum(sum.(x.Z))
end
function MultivariatePolynomials.maxdegree(x::MonomialVector)
    return isempty(x) ? 0 : maximum(sum.(x.Z))
end
# Complex-valued degrees for monomial vectors
for (fun, call, def, ret) in [
    (:extdegree_complex, :extrema, (0, 0), :((min(v1, v2), max(v1, v2)))),
    (:mindegree_complex, :minimum, 0, :(min(v1, v2))),
    (:maxdegree_complex, :maximum, 0, :(max(v1, v2))),
]
    eval(quote
        function MultivariatePolynomials.$fun(x::MonomialVector)
            isempty(x) && return $def
            vars = variables(x)
            @assert(!any(isrealpart, vars) && !any(isimagpart, vars))
            grouping = isconj.(vars)
            v1 = $call(sum(z[grouping]) for z in x.Z)
            grouping = map(!, grouping)
            v2 = $call(sum(z[grouping]) for z in x.Z)
            return $ret
        end
    end)
end
# faster complex-related functions
Base.isreal(x::MonomialVector) = all(isreal, x.vars)
Base.conj(x::MonomialVector) = MonomialVector(conj.(x.vars), x.Z)

MP.variables(m::Union{Monomial,MonomialVector}) = m.vars

# Recognize arrays of monomials of this module
# [x, y] -> Vector{Variable}
# [x, x*y] -> Vector{Monomial}
# [1, x] -> Vector{Term{Int}}
const DMonoVecElemNonConstant{V,M} =
    Union{Variable{V,M},Monomial{V,M},_Term{V,M}}
# [1] -> Vector{Int}
const DMonoVecElem{V,M} = Union{Int,DMonoVecElemNonConstant{V,M}}
const DMonoVec{V,M} = AbstractVector{<:DMonoVecElem{V,M}}

function MP.empty_monomial_vector(
    vars::AbstractVector{Variable{V,M}},
) where {V,M}
    return MonomialVector{V,M}(vars, Vector{Int}[])
end
function MP.empty_monomial_vector(t::DMonoVecElemNonConstant)
    return empty_monomial_vector(MP.variables(t))
end
function MP.empty_monomial_vector(
    ::Type{<:DMonoVecElemNonConstant{V,M}},
) where {V,M}
    return MonomialVector{V,M}()
end

# TODO replace by MP function
function _error_for_negative_degree(deg)
    if deg < 0
        throw(
            ArgumentError(
                "The degree should be a nonnegative number but the provided degree `$deg` is negative.",
            ),
        )
    end
end

function _fill_noncomm_exponents_rec!(Z, z, i, n, deg, ::Type{MP.LexOrder}, filter::Function)
    if deg == 0
        if filter(z)
            push!(Z, copy(z))
        end
    else
        for i in i:i+n-1
            z[i] += 1
            _fill_noncomm_exponents_rec!(Z, z, i, n, deg - 1, LexOrder, filter)
            z[i] -= 1
        end
    end
end

function _fill_exponents!(
    Z,
    n,
    deg,
    ::Type{NonCommutative},
    ::Type{MP.LexOrder},
    filter::Function,
    maxdeg::Int,
)
    _error_for_negative_degree(deg)
    _error_for_negative_degree(maxdeg)
    z = zeros(Int, maxdeg * n - maxdeg + 1)
    start = length(Z) + 1
    _fill_noncomm_exponents_rec!(Z, z, 1, n, deg, MP.LexOrder, filter)
    return reverse!(view(Z, start:length(Z)))
end

function _fill_exponents!(
    Z::Vector{Vector{Int}},
    n,
    degs::AbstractVector{Int},
    ::Type{V},
    ::Type{MP.Graded{M}},
    filter::Function,
) where {V,M}
    # For non-commutative, lower degree need to create a vector of exponent as large as for the highest degree
    maxdeg = maximum(degs, init = 0)
    for deg in sort(degs)
        _fill_exponents!(Z, n, deg, V, M, filter, maxdeg)
    end
    return
end

# List exponents in decreasing Graded Lexicographic Order
function _all_exponents(
    n,
    degs::AbstractVector{Int},
    ::Type{V},
    ::Type{M},
    filter::Function,
) where {V,M}
    Z = Vector{Int}[]
    _fill_exponents!(Z, n, degs, V, M, filter)
    _isless = let M = M
        (a, b) -> MP.compare(a, b, M) < 0
    end
    @assert issorted(Z, lt = _isless)
    return Z
end

function getvarsforlength(vars::Vector{<:Variable{<:NonCommutative}}, len::Int)
    n = length(vars)
    return map(i -> vars[((i-1)%n)+1], 1:len)
end

function MonomialVector(
    vars::Vector{<:Variable{<:NonCommutative,M}},
    degs::AbstractVector{Int},
    filter::Function = x -> true,
) where {M}
    vars = unique!(sort(vars, rev = true))
    Z = _all_exponents(
        length(vars),
        degs,
        NonCommutative,
        M,
        z -> filter(Monomial(getvarsforlength(vars, length(z)), z)),
    )
    v = isempty(Z) ? vars : getvarsforlength(vars, length(first(Z)))
    return MonomialVector(v, Z)
end

function MonomialVector(
    vars::Vector{<:Variable{<:Commutative,M}},
    degs::AbstractVector{Int},
    filter::Function = x -> true,
) where {M}
    vars = unique!(sort(vars, rev = true))
    if isempty(degs)
        mindegree = 0
        maxdegree = -1
    else
        mindegree = minimum(degs)
        maxdegree = maximum(degs)
    end
    Z = Iterators.Filter(MP.ExponentsIterator{M}(
        zeros(Int, length(vars));
        mindegree,
        maxdegree,
    )) do z
        mono = Monomial(vars, z)
        MP.degree(mono) in degs && filter(mono)
    end
    return MonomialVector(vars, collect(Z))
end

function MonomialVector(
    vars::Vector{<:Variable},
    degs::Int,
    filter::Function = x -> true,
)
    return MonomialVector(vars, [degs], filter)
end

function MP.monomials(vars::AbstractVector{<:Variable}, args...)
    return MonomialVector(vars, args...)
end

function MP.monomials(vars::Tuple{Vararg{Variable}}, args...)
    return monomials([vars...], args...)
end

#function MP.monomials(vars::TupOrVec{Variable{true}}, degs::AbstractVector{Int}, filter::Function = x->true)
#    Z = _all_exponents(length(vars), degs, true, z -> filter(Monomial(vars, z)))
#    [Monomial{true}(vars, z) for z in Z]
#end
#function MP.monomials(vars::TupOrVec{<:Variable{<:NonCommutative}}, degs::AbstractVector{Int}, filter::Function = x->true)
#    Z = _all_exponents(length(vars), degs, false, z -> filter(Monomial(vars, z)))
#    v = isempty(Z) ? vars : getvarsforlength(vars, length(first(Z)))
#    [Monomial(v, z) for z in Z]
#end
#MP.monomials(vars::TupOrVec{PV}, degs::Int, filter::Function = x->true) where {PV<:Variable} = monomials(vars, [degs], filter)

function buildZvarsvec(::Type{PV}, X::DMonoVec) where {PV<:Variable}
    varsvec = Vector{PV}[
        (isa(x, DMonoVecElemNonConstant) ? MP.variables(x) : Variable[]) for
        x in X
    ]
    allvars, maps = mergevars(varsvec)
    nvars = length(allvars)
    Z = [zeros(Int, nvars) for i in 1:length(X)]
    for (i, x) in enumerate(X)
        if isa(x, Variable)
            @assert length(maps[i]) == 1
            z = [1]
        elseif isa(x, Monomial)
            z = x.z
        elseif isa(x, _Term)
            z = MP.monomial(x).z
        else
            @assert isa(x, Int)
            z = Int[]
        end
        Z[i][maps[i]] = z
    end
    return allvars, Z
end

MP.sort_monomial_vector(X::MonomialVector) = (1:length(X), X)
function _sort_monomial_vector(X::DMonoVec{V,M}) where {V,M}
    allvars, Z = buildZvarsvec(Variable{V,M}, X)
    _isless = let M = M
        (a, b) -> MP.compare(a, b, M) < 0
    end
    σ = sortperm(Z, lt = _isless)
    return allvars, Z, σ
end
function _removedups!(Z::Vector{Vector{Int}}, σ::Vector{Int})
    dups = findall(i -> Z[σ[i]] == Z[σ[i-1]], 2:length(σ))
    return deleteat!(σ, dups)
end
function MP.sort_monomial_vector(X::DMonoVec{V,M}) where {V,M}
    if isempty(X)
        Int[], MonomialVector{V,M}()
    else
        allvars, Z, σ = _sort_monomial_vector(X)
        _removedups!(Z, σ)
        σ, MonomialVector{V,M}(allvars, Z[σ])
    end
end

function MonomialVector{V,M}(X::DMonoVec{V,M}) where {V,M}
    allvars, Z = buildZvarsvec(Variable{V,M}, X)
    _isless = let M = M
        (a, b) -> cmp(M(), a, b) < 0
    end
    sort!(Z, lt = _isless)
    dups = findall(i -> Z[i] == Z[i-1], 2:length(Z))
    deleteat!(Z, dups)
    return MonomialVector{V,M}(allvars, Z)
end
function MonomialVector(X)
    return monomial_vector_type(X)(X)
end

function MP.monomial_vector_type(
    ::Union{
        DMonoVecElemNonConstant{V,M},
        Type{<:DMonoVecElemNonConstant{V,M}},
        DMonoVec{V,M},
        Type{<:DMonoVec{V,M}},
    },
) where {V,M}
    return MonomialVector{V,M}
end
function MP.monomial_vector(X::DMonoVec)
    return MonomialVector(X)
end
MP.monomial_vector(a, mv::MonomialVector) = (a, mv)

function MP.merge_monomial_vectors(ms::Vector{MonomialVector{V,M}}) where {V,M}
    m = length(ms)
    I = ones(Int, length(ms))
    L = length.(ms)
    X = Monomial{V,M}[]
    while any(I .<= L)
        min_monomial = nothing
        for i in 1:m
            if I[i] <= L[i]
                x = ms[i][I[i]]
                if min_monomial === nothing || min_monomial > x
                    min_monomial = x
                end
            end
        end
        @assert min_monomial !== nothing
        # to ensure that max is no more a union
        min_monomial === nothing && return X
        push!(X, min_monomial)
        for i in 1:m
            if I[i] <= L[i] && min_monomial == ms[i][I[i]]
                I[i] += 1
            end
        end
    end
    # There is no duplicate by construction
    return MonomialVector{V,M}(buildZvarsvec(Variable{V,M}, X)...)
end

function __add_variables!(
    monos::MonomialVector{V,M},
    allvars::Vector{Variable{V,M}},
    map,
) where {V,M}
    copy!(monos.vars, allvars)
    if !isempty(monos.Z)
        tmp = similar(first(monos.Z))
        for z in monos.Z
            copy!(tmp, z)
            resize!(z, length(allvars))
            fill!(z, 0)
            z[map] = tmp
        end
    end
end

function multiplyexistingvar(i::Int, z::Vector{Int})
    newz = copy(z)
    newz[i] += 1
    return newz
end
function multiplyexistingvar(i::Int, Z::Vector{Vector{Int}})
    return Vector{Int}[multiplyexistingvar(i, z) for z in Z]
end
function insertvar(
    v::Vector{Variable{V,M}},
    x::Variable{V,M},
    i::Int,
) where {V,M}
    n = length(v)
    I = 1:i-1
    J = i:n
    K = J .+ 1
    w = Vector{Variable{V,M}}(undef, n + 1)
    w[I] = v[I]
    w[i] = x
    w[K] = v[J]
    return w
end
function insertvar(z::Vector{Int}, x::Variable, i::Int)
    n = length(z)
    I = 1:i-1
    J = i:n
    K = J .+ 1
    newz = Vector{Int}(undef, n + 1)
    newz[I] = z[I]
    newz[i] = 1
    newz[K] = z[J]
    return newz
end
function insertvar(Z::Vector{Vector{Int}}, x::Variable, i::Int)
    return Vector{Int}[insertvar(z, x, i) for z in Z]
end

include("cmult.jl")
include("ncmult.jl")

MP.left_constant_mult(α, x::Monomial) = MP.term(α, MA.mutable_copy(x))

function zero_with_variables(
    ::Type{Polynomial{V,M,T}},
    vars::Vector{Variable{V,M}},
) where {V,M,T}
    return Polynomial(T[], empty_monomial_vector(vars))
end

# I do not want to cast x to TermContainer because that would force the promotion of eltype(q) with Int
function Base.:(*)(x::DMonomialLike, p::Polynomial)
    return Polynomial(MA.mutable_copy(p.a), x * p.x)
end
function Base.:(*)(x::DMonomialLike{<:NonCommutative}, p::Polynomial)
    # Order may change, e.g. y * (x + y) = y^2 + yx
    return Polynomial(
        monomial_vector(MA.mutable_copy(p.a), [x * m for m in p.x])...,
    )
end

function _term_poly_mult(
    t::_Term{V,M,S},
    p::Polynomial{V,M,T},
    op::Function,
) where {V,M,S,T}
    U = MA.promote_operation(op, S, T)
    if iszero(t)
        zero(Polynomial{V,M,U})
    else
        n = nterms(p)
        allvars, maps = mergevars([MP.monomial(t).vars, p.x.vars])
        nv = length(allvars)
        # Necessary to annotate the type in case it is empty
        Z = Vector{Int}[zeros(Int, nv) for i in 1:n]
        for i in 1:n
            Z[i][maps[1]] = MP.monomial(t).z
            Z[i][maps[2]] += p.x.Z[i]
        end
        Polynomial(op.(MP.coefficient(t), p.a), MonomialVector(allvars, Z))
    end
end
Base.:(*)(p::Polynomial, t::_Term) = _term_poly_mult(t, p, (α, β) -> β * α)
Base.:(*)(t::_Term, p::Polynomial) = _term_poly_mult(t, p, *)
_sumprod(a, b) = a * b + a * b
function _mul(
    ::Type{T},
    p::AbstractPolynomialLike,
    q::AbstractPolynomialLike,
) where {T}
    return _mul(T, polynomial(p), polynomial(q))
end
function _mul(
    ::Type{T},
    p::Polynomial{<:Commutative},
    q::Polynomial{<:Commutative},
) where {T}
    samevars = MP.variables(p) == MP.variables(q)
    if samevars
        allvars = copy(MP.variables(p))
    else
        allvars, maps = mergevars([MP.variables(p), MP.variables(q)])
    end
    N = MP.nterms(p) * MP.nterms(q)
    Z = Vector{Vector{Int}}(undef, N)
    a = Vector{T}(undef, N)
    i = 0
    for u in MP.terms(p)
        for v in MP.terms(q)
            if samevars
                z = MP.monomial(u).z + MP.monomial(v).z
            else
                z = zeros(Int, length(allvars))
                z[maps[1]] += MP.monomial(u).z
                z[maps[2]] += MP.monomial(v).z
            end
            i += 1
            Z[i] = z
            a[i] = MP.coefficient(u) * MP.coefficient(v)
        end
    end
    return allvars, a, Z
end
function Base.:(*)(
    p::Polynomial{V,M,S},
    q::Polynomial{V,M,T},
) where {V<:Commutative,M,S,T}
    PT = MA.promote_operation(*, typeof(p), typeof(q))
    if iszero(p) || iszero(q)
        zero(PT)
    else
        polynomialclean(_mul(MP.coefficient_type(PT), p, q)...)
    end
end
function MA.operate_to!(
    p::Polynomial{V,M,T},
    ::typeof(*),
    q1::MP.AbstractPolynomialLike,
    q2::MP.AbstractPolynomialLike,
) where {V<:NonCommutative,M,T}
    if iszero(q1) || iszero(q2)
        MA.operate!(zero, p)
    else
        ts = _Term{V,M,T}[]
        MP.mul_to_terms!(ts, q1, q2)
        # TODO do better than create tmp
        tmp = polynomial!(ts)
        Future.copy!(p.a, tmp.a)
        Future.copy!(p.x.vars, tmp.x.vars)
        Future.copy!(p.x.Z, tmp.x.Z)
        return p
    end
end
function MA.operate_to!(
    p::Polynomial{<:Commutative,M,T},
    ::typeof(*),
    q1::MP.AbstractPolynomialLike,
    q2::MP.AbstractPolynomialLike,
) where {M,T}
    if iszero(q1) || iszero(q2)
        MA.operate!(zero, p)
    else
        polynomialclean_to!(p, _mul(T, q1, q2)...)
    end
end
function MA.operate!(
    ::typeof(*),
    p::Polynomial{V,M},
    q::Polynomial{V,M},
) where {V,M}
    if iszero(q)
        return MA.operate!(zero, p)
    elseif nterms(q) == 1
        return MA.operate!(*, p, MP.leading_term(q))
    else
        return MA.operate_to!(p, *, p, q)
    end
end

function MP.divides(m1::Monomial{<:NonCommutative}, m2::Monomial{<:NonCommutative})
    error("Not implemented yet")
end
function MP.divides(m1::Monomial{<:Commutative}, m2::Monomial{<:Commutative})
    e1 = exponents(m1)
    v1 = variables(m1)
    e2 = exponents(m2)
    v2 = variables(m2)
    i = 1
    lI = length(e1)
    j = 1
    lJ = length(e2)
    while i <= lI || j <= lJ
        if i > lI || (j <= lJ && v2[j] > v1[i])
            j += 1
        elseif j > lJ || (i <= lI && v1[i] > v2[j])
            iszero(e1[i]) || return false
            i += 1
        else
            @assert v1[i] == v2[j]
            e1[i] <= e2[j] || return false
            i += 1
            j += 1
        end
    end
    return true
end
